/******************** COPYRIGHT  ********************
* File Name       : LT738.h
* Author          : Levetop Electronics
* Version         : V1.0
* Date            : 2017-8-25
* Description     : LT738ļĴ
****************************************************/

#ifndef _LT738_h
#define _LT738_h

#include "LT738.h"
#include "lcd.h"

#define	cSetb0		0x01
#define	cSetb1		0x02
#define	cSetb2		0x04
#define	cSetb3		0x08
#define	cSetb4		0x10
#define	cSetb5		0x20
#define	cSetb6		0x40
#define	cSetb7		0x80

#define	cClrb0		0xfe
#define	cClrb1		0xfd
#define	cClrb2		0xfb
#define	cClrb3		0xf7
#define	cClrb4		0xef
#define	cClrb5		0xdf
#define	cClrb6		0xbf
#define	cClrb7		0x7f


void LCD_RegisterWrite(unsigned char Cmd,unsigned char Data);
unsigned char LCD_RegisterRead(unsigned char Cmd);


//void LT738_initial(void);
////Set PLL
//void LT738_PLL_Initial(void); 
////Set SDRAM 
//void LT738_SDRAM_initail(void);


//**Staus**//
void Check_Mem_WR_FIFO_not_Full(void);
void Check_2D_Busy(void);
void Check_SDRAM_Ready(void);
void Check_Mem_WR_FIFO_Empty(void);
void Check_Busy_Draw(void);

//**[00h]**//
void LT738_SW_Reset(void);
void TFT_16bit(void);
void Host_Bus_16bit(void);
//**[02h]**//
void RGB_16b_16bpp(void);

void MemWrite_Left_Right_Top_Down(void);

void Graphic_Mode(void);
void Text_Mode(void);
void Memory_Select_SDRAM(void);


void Select_Main_Window_16bpp(void);

void PCLK_Falling(void);
void Display_ON(void);

void VSCAN_T_to_B(void);
void VSCAN_B_to_T(void);
void PDATA_Set_RGB(void);


//**[13h]**//
void HSYNC_Low_Active(void);

void VSYNC_Low_Active(void);

void DE_High_Active(void);

void LCD_HorizontalWidth_VerticalHeight(unsigned short WX,unsigned short HY);
//**[16h][17h]**//
void LCD_Horizontal_Non_Display(unsigned short WX);
//**[18h]**//
void LCD_HSYNC_Start_Position(unsigned short WX);
//**[19h]**//
void LCD_HSYNC_Pulse_Width(unsigned short WX);
//**[1Ch][1Dh]**//
void LCD_Vertical_Non_Display(unsigned short HY);
//**[1Eh]**//
void LCD_VSYNC_Start_Position(unsigned short HY);
//**[1Fh]**//
void LCD_VSYNC_Pulse_Width(unsigned short HY);
//**[20h][21h][22h][23h]**//
void Main_Image_Start_Address(unsigned long Addr);
//**[24h][25h]**//					
void Main_Image_Width(unsigned short WX);							
//**[26h][27h][28h][29h]**//
void Main_Window_Start_XY(unsigned short WX,unsigned short HY);	
//**[2Ah][2Bh][2Ch][2Dh]**//
void PIP_Display_Start_XY(unsigned short WX,unsigned short HY);
//**[2Eh][2Fh][30h][31h]**//
void PIP_Image_Start_Address(unsigned long Addr);
//**[32h][33h]**//
void PIP_Image_Width(unsigned short WX);
//**[34h][35h][36h][37h]**//
void PIP_Window_Image_Start_XY(unsigned short WX,unsigned short HY);
//**[38h][39h][3Ah][3Bh]**//

void Canvas_Image_Start_address(unsigned long Addr);
//**[54h][55h]**//
void Canvas_image_width(unsigned short WX);
//**[56h][57h][58h][59h]**//
void Active_Window_XY(unsigned short WX,unsigned short HY);
//**[5Ah][5Bh][5Ch][5Dh]**//
void Active_Window_WH(unsigned short WX,unsigned short HY);
//**[5E]**//

void Memory_XY_Mode(void);
void Memory_16bpp_Mode(void);

void Goto_Pixel_XY(unsigned short WX,unsigned short HY);
	
void Square_Start_XY(unsigned short WX,unsigned short HY);		
void Square_End_XY(unsigned short WX,unsigned short HY);		
//**[76h]**//

void Start_Square_Fill(void);

////////////////////////////////////////////////////////////////////////
////**** [ Function : PWM ] ****////
//**[84h]**//
void Set_PWM_Prescaler_1_to_256(unsigned short WX);
//**[85h]**//
void Select_PWM1_Clock_Divided_By_1(void);
void Select_PWM1_Clock_Divided_By_2(void);
void Select_PWM1_Clock_Divided_By_4(void);
void Select_PWM1_Clock_Divided_By_8(void);
void Select_PWM0_Clock_Divided_By_1(void);
void Select_PWM0_Clock_Divided_By_2(void);
void Select_PWM0_Clock_Divided_By_4(void);
void Select_PWM0_Clock_Divided_By_8(void);
//[85h].[bit3][bit2]
void Select_PWM1_is_ErrorFlag(void);
void Select_PWM1(void);
void Select_PWM0(void);

void Start_PWM1(void);
void Stop_PWM1(void);
//[86h]PWM0
void Start_PWM0(void);
void Stop_PWM0(void);
//**[87h]**//
void Set_Timer0_Compare_Buffer(unsigned short WX);
//**[8Ah][8Bh]**//
void Set_Timer0_Count_Buffer(unsigned short WX);
//**[8Ch][8Dh]**//
void Set_Timer1_Compare_Buffer(unsigned short WX);
//**[8Eh][8Fh]**//
void Set_Timer1_Count_Buffer(unsigned short WX);
//**[D2h][D3h][D4h]**//
void Foreground_color_65k(unsigned short temp);

#endif
