#ifndef _LT738_Lib_H
#define _LT738_Lib_H
#include "LT738.h"
#include "if_port.h"

//ֱ
#define LCD_XSIZE_TFT    1024	
#define LCD_YSIZE_TFT    600
//
#define LCD_VBPD		 20
#define LCD_VFPD	 	 12
#define LCD_VSPW		 3
#define LCD_HBPD		 140
#define LCD_HFPD		 160
#define LCD_HSPW	   	 20

#define color256_black   0x00
#define color256_white   0xff
#define color256_red     0xe0
#define color256_green   0x1c
#define color256_blue    0x03
#define color256_yellow  color256_red|color256_green
#define color256_cyan    color256_green|color256_blue
#define color256_purple  color256_red|color256_blue
 
#define color65k_black   0x0000
#define color65k_white   0xffff
#define color65k_red     0xf800
#define color65k_green   0x07e0
#define color65k_blue    0x001f
#define color65k_yellow  color65k_red|color65k_green
#define color65k_cyan    color65k_green|color65k_blue
#define color65k_purple  color65k_red|color65k_blue

#define color65k_grayscale1    2113
#define color65k_grayscale2    2113*2
#define color65k_grayscale3    2113*3
#define color65k_grayscale4    2113*4
#define color65k_grayscale5    2113*5
#define color65k_grayscale6    2113*6
#define color65k_grayscale7    2113*7
#define color65k_grayscale8    2113*8
#define color65k_grayscale9    2113*9
#define color65k_grayscale10   2113*10
#define color65k_grayscale11   2113*11
#define color65k_grayscale12   2113*12
#define color65k_grayscale13   2113*13
#define color65k_grayscale14   2113*14
#define color65k_grayscale15   2113*15
#define color65k_grayscale16   2113*16
#define color65k_grayscale17   2113*17
#define color65k_grayscale18   2113*18
#define color65k_grayscale19   2113*19
#define color65k_grayscale20   2113*20
#define color65k_grayscale21   2113*21
#define color65k_grayscale22   2113*22
#define color65k_grayscale23   2113*23
#define color65k_grayscale24   2113*24
#define color65k_grayscale25   2113*25
#define color65k_grayscale26   2113*26
#define color65k_grayscale27   2113*27
#define color65k_grayscale28   2113*28
#define color65k_grayscale29   2113*29
#define color65k_grayscale30   2113*30

 
#define color16M_black   0x00000000
#define color16M_white   0x00ffffff
#define color16M_red     0x00ff0000
#define color16M_green   0x0000ff00
#define color16M_blue    0x000000ff
#define color16M_yellow  color16M_red|color16M_green
#define color16M_cyan    color16M_green|color16M_blue
#define color16M_purple  color16M_red|color16M_blue


/* LCD color */
#define White          0xFFFF
#define Black          0x0000
#define Grey           0xF7DE
#define Blue           0x001F
#define Blue2          0x051F
#define Red            0xF800
#define Magenta        0xF81F
#define Green          0x07E0
#define Cyan           0x7FFF
#define Yellow         0xFFE0

#define Line0          0
#define Line1          24
#define Line2          48
#define Line3          72
#define Line4          96
#define Line5          120
#define Line6          144
#define Line7          168
#define Line8          192
#define Line9          216
#define Line10         240
#define Line11         264
#define Line12         288
#define Line13         312
#define Line14         336
#define Line15         360
#define Line16         384
#define Line17         408
#define Line18         432
#define Line19         456
#define Line20         480
#define Line21         504
#define Line22         528
#define Line23         552
#define Line24         576
#define Line25         600


void LT738_Init(void);
void LT738_DrawSquare_Fill(unsigned short X1,unsigned short Y1,unsigned short X2,unsigned short Y2,unsigned long ForegroundColor);
void LT738_PWM0_Init(unsigned char on_off,unsigned char Clock_Divided,unsigned char Prescalar,unsigned short Count_Buffer,unsigned short Compare_Buffer);
void LT738_PWM1_Init(unsigned char on_off,unsigned char Clock_Divided,unsigned char Prescalar,unsigned short Count_Buffer,unsigned short Compare_Buffer);
void LT738_PWM0_Duty(unsigned short Compare_Buffer);
void LT738_PWM1_Duty(unsigned short Compare_Buffer);
void MPU_Memory_Write_Window_8bit(unsigned short x,unsigned short y,unsigned short w,unsigned short h,const unsigned char *data);
void MPU_Memory_Write_Pixel_8bit(unsigned short x,unsigned short y,unsigned short w,unsigned short h,const unsigned char *data);
void Memory_Write_Flash(u16 x,u16 y,u16 w,u16 h,u32 addr);

#endif












































//const unsigned char fan[103968] = {
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0x1C, 0xE7, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0x9A, 0xD6, 0x59, 0xCE, 0xF7, 0xBD, 0xB6, 0xB5, 0x75, 0xAD, 0x14, 0xA5, 0xF3, 0x9C, 
//	0xB2, 0x94, 0x92, 0x94, 0x71, 0x8C, 0x51, 0x8C, 0x30, 0x84, 0x30, 0x84, 0x30, 0x84, 0x10, 0x84, 
//	0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x30, 0x84, 0x30, 0x84, 
//	0x51, 0x8C, 0x51, 0x8C, 0x71, 0x8C, 0x92, 0x94, 0xD3, 0x9C, 0xF3, 0x9C, 0x34, 0xA5, 0x96, 0xB5, 
//	0xD7, 0xBD, 0x38, 0xC6, 0x79, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0x1C, 0xE7, 0x1C, 0xE7, 0x1C, 0xE7, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0x1C, 0xE7, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0x59, 0xCE, 0xF7, 0xBD, 0x75, 0xAD, 0xF3, 0x9C, 0x71, 0x8C, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xAE, 0x73, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 0xAE, 0x73, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x30, 0x84, 
//	0xB2, 0x94, 0x14, 0xA5, 0x96, 0xB5, 0x18, 0xC6, 0x79, 0xCE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0x1C, 0xE7, 0xFB, 0xDE, 0x9A, 0xD6, 
//	0x18, 0xC6, 0x75, 0xAD, 0xB2, 0x94, 0x51, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 
//	0xEF, 0x7B, 0x10, 0x84, 0x10, 0x84, 0xEF, 0x7B, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x10, 0x84, 0x51, 0x8C, 0xF3, 0x9C, 0x96, 0xB5, 0x38, 0xC6, 0xBA, 0xD6, 0xFB, 0xDE, 0x1C, 0xE7, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 0x9A, 0xD6, 
//	0x18, 0xC6, 0x34, 0xA5, 0x92, 0x94, 0x10, 0x84, 0xCF, 0x7B, 0xAE, 0x73, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 
//	0x51, 0x8C, 0x71, 0x8C, 0xD3, 0x9C, 0x14, 0xA5, 0x55, 0xAD, 0x96, 0xB5, 0xB6, 0xB5, 0xF7, 0xBD, 
//	0x18, 0xC6, 0x18, 0xC6, 0x59, 0xCE, 0x59, 0xCE, 0x59, 0xCE, 0x59, 0xCE, 0x59, 0xCE, 0x59, 0xCE, 
//	0x59, 0xCE, 0x59, 0xCE, 0x18, 0xC6, 0x18, 0xC6, 0x18, 0xC6, 0xD7, 0xBD, 0xB6, 0xB5, 0x75, 0xAD, 
//	0x55, 0xAD, 0x14, 0xA5, 0xB2, 0x94, 0x71, 0x8C, 0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 
//	0xEF, 0x7B, 0x30, 0x84, 0xB2, 0x94, 0x75, 0xAD, 0x38, 0xC6, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 
//	0x79, 0xCE, 0xB6, 0xB5, 0xD3, 0x9C, 0x30, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x71, 0x8C, 0xD3, 0x9C, 
//	0x55, 0xAD, 0xD7, 0xBD, 0x38, 0xC6, 0x59, 0xCE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x59, 0xCE, 0x18, 0xC6, 0x96, 0xB5, 0x14, 0xA5, 0xB2, 0x94, 0x51, 0x8C, 0x10, 0x84, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 
//	0xEF, 0x7B, 0x51, 0x8C, 0x14, 0xA5, 0xF7, 0xBD, 0x9A, 0xD6, 0xFB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0x79, 0xCE, 0x96, 0xB5, 0xB2, 0x94, 0xEF, 0x7B, 0xAE, 0x73, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0x51, 0x8C, 0xD3, 0x9C, 0x96, 0xB5, 
//	0x18, 0xC6, 0x79, 0xCE, 0xBA, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x79, 0xCE, 0xF7, 0xBD, 0x55, 0xAD, 0xB2, 0x94, 0x30, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x30, 0x84, 0xF3, 0x9C, 0xD7, 0xBD, 0xBA, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x1C, 0xE7, 0xFB, 0xDE, 0x79, 0xCE, 0x96, 0xB5, 0xB2, 0x94, 0xEF, 0x7B, 0xAE, 0x73, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0x51, 0x8C, 0x14, 0xA5, 0xB6, 0xB5, 
//	0x59, 0xCE, 0xBA, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0x18, 0xC6, 0x96, 0xB5, 0xD3, 0x9C, 0x30, 0x84, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 
//	0xF3, 0x9C, 0xD7, 0xBD, 0xBA, 0xD6, 0x1C, 0xE7, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0xDB, 0xDE, 0xF7, 0xBD, 0xD3, 0x9C, 0x10, 0x84, 0xAE, 0x73, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xB2, 0x94, 0x75, 0xAD, 
//	0x38, 0xC6, 0xBA, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0xF7, 0xBD, 0x34, 0xA5, 0x71, 0x8C, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0x55, 0xAD, 
//	0x59, 0xCE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 0x75, 0xAD, 0x51, 0x8C, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xD3, 0x9C, 
//	0xB6, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x38, 0xC6, 0x75, 0xAD, 0x92, 0x94, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 0xEF, 0x7B, 0xB2, 0x94, 0xD7, 0xBD, 0xBA, 0xD6, 
//	0x1C, 0xE7, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 0x38, 0xC6, 
//	0x14, 0xA5, 0x10, 0x84, 0xAE, 0x73, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x10, 0x84, 
//	0xD3, 0x9C, 0xB6, 0xB5, 0x79, 0xCE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0x38, 0xC6, 0x75, 0xAD, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 0x51, 0x8C, 0x75, 0xAD, 0x9A, 0xD6, 0x1C, 0xE7, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xF7, 0xBD, 0xB2, 0x94, 0xEF, 0x7B, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x51, 0x8C, 0x75, 0xAD, 0x59, 0xCE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0x18, 0xC6, 0x14, 0xA5, 0x30, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xAE, 0x73, 0x10, 0x84, 0x34, 0xA5, 0x79, 0xCE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x92, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xD3, 0x9C, 0xF7, 0xBD, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 
//	0xB6, 0xB5, 0x92, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0xEF, 0x7B, 
//	0x14, 0xA5, 0x79, 0xCE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x18, 0xC6, 0xB2, 0x94, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x34, 0xA5, 0x59, 0xCE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0xD3, 0x9C, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0xEF, 0x7B, 0x14, 0xA5, 0x79, 0xCE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x38, 0xC6, 
//	0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0x75, 0xAD, 
//	0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0xEF, 0x7B, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0xEF, 0x7B, 0x34, 0xA5, 0x9A, 0xD6, 0x1C, 0xE7, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x1C, 0xE7, 0x9A, 0xD6, 0x14, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x51, 0x8C, 0x96, 0xB5, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xAE, 0x73, 0x10, 0x84, 0x96, 0xB5, 0xDB, 0xDE, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x75, 0xAD, 0x10, 0x84, 0xAE, 0x73, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0x96, 0xB5, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x59, 0xCE, 0x14, 0xA5, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x71, 0x8C, 
//	0xF7, 0xBD, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x18, 0xC6, 0x71, 0x8C, 
//	0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x75, 0xAD, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0xF3, 0x9C, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0x79, 0xCE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 
//	0x9A, 0xD6, 0x14, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0x14, 0xA5, 
//	0x79, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0x18, 0xC6, 0x92, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x10, 0x84, 0xAE, 0x73, 0x10, 0x84, 0x96, 0xB5, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xD7, 0xBD, 0x30, 0x84, 0xAE, 0x73, 0x10, 0x84, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xB2, 0x94, 0x38, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x9A, 0xD6, 
//	0x79, 0xCE, 0x59, 0xCE, 0x38, 0xC6, 0x18, 0xC6, 0x18, 0xC6, 0xF7, 0xBD, 0xD7, 0xBD, 0xD7, 0xBD, 
//	0xB6, 0xBD, 0xD7, 0xBD, 0xD7, 0xBD, 0xD7, 0xBD, 0xB6, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0x18, 0xC6, 0x38, 0xC6, 0x59, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xB6, 0xB5, 0x30, 0x84, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 
//	0x92, 0x94, 0x59, 0xCE, 0x1C, 0xE7, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x9A, 0xD6, 0xD3, 0x9C, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0xB6, 0xB5, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x9A, 0xD6, 0x59, 0xCE, 0x38, 0xC6, 0xF7, 0xBD, 
//	0xB6, 0xB5, 0x75, 0xAD, 0x55, 0xAD, 0x34, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0x34, 0xA5, 0x34, 0xAD, 0x75, 0xAD, 0x96, 0xB5, 0xD7, 0xBD, 0x18, 0xC6, 0x59, 0xCE, 0x9A, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x9A, 0xD6, 
//	0x34, 0xA5, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x75, 0xAD, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xF7, 0xBD, 0x30, 0x84, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0x79, 0xCE, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x79, 0xCE, 0x18, 0xC6, 0xD7, 0xBD, 0x96, 0xB5, 
//	0x34, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0xF3, 0xA4, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 
//	0x34, 0xA5, 0x55, 0xA5, 0x55, 0xA5, 0x55, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 
//	0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 
//	0x75, 0xA5, 0x55, 0xA5, 0x55, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x75, 0xAD, 0xB6, 0xB5, 0x18, 0xC6, 0x59, 0xCE, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0x18, 0xC6, 0x71, 0x8C, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0xB2, 0x94, 0x79, 0xCE, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x34, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 
//	0x51, 0x8C, 0xD7, 0xBD, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x79, 0xCE, 0x18, 0xC6, 0xB6, 0xB5, 0x55, 0xAD, 
//	0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 
//	0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x34, 0xA5, 0x14, 0xAD, 0xF3, 0xAC, 0xB2, 0xAC, 0x51, 0xB4, 
//	0x10, 0xB4, 0xCF, 0xBB, 0x8E, 0xBB, 0x6D, 0xC3, 0x6D, 0xC3, 0x6D, 0xC3, 0x6D, 0xC3, 0x6D, 0xC3, 
//	0x6D, 0xC3, 0x8E, 0xC3, 0xCF, 0xBB, 0xEF, 0xBB, 0x30, 0xB4, 0x92, 0xAC, 0xD3, 0xAC, 0xF3, 0xAC, 
//	0x14, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 
//	0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x55, 0xAD, 0x96, 0xB5, 0xF7, 0xBD, 0x59, 0xCE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 0x75, 0xAD, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 
//	0x10, 0x84, 0xD7, 0xBD, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x59, 0xCE, 0x71, 0x8C, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0x9A, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x79, 0xCE, 0xF7, 0xBD, 0x75, 0xAD, 
//	0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 
//	0x55, 0xA5, 0x14, 0xA5, 0x92, 0xAC, 0x10, 0xB4, 0x6D, 0xC3, 0xAA, 0xCA, 0x08, 0xDA, 0x65, 0xE1, 
//	0x04, 0xE9, 0x82, 0xF0, 0x20, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x61, 0xF0, 0xC3, 0xE8, 0x24, 0xE1, 0xC7, 0xD9, 0x69, 0xD2, 0x2C, 0xC3, 
//	0xEF, 0xBB, 0x71, 0xB4, 0xF3, 0xA4, 0x55, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x55, 0xA5, 
//	0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x55, 0xAD, 0xB6, 0xB5, 0x38, 0xC6, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x38, 0xC6, 0x71, 0x8C, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x14, 0xA5, 0xBA, 0xD6, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xD7, 0xBD, 0x10, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xB6, 0xB5, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x79, 0xCE, 0xD7, 0xBD, 
//	0x75, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 
//	0x34, 0xA5, 0xB2, 0xAC, 0xEF, 0xBB, 0x0C, 0xCB, 0x08, 0xDA, 0x04, 0xE9, 0x41, 0xF0, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0xC3, 0xE8, 0xA6, 0xE1, 
//	0xAA, 0xCA, 0x8E, 0xC3, 0x71, 0xB4, 0x14, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 0x55, 0xA5, 0x34, 0xA5, 
//	0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0xB6, 0xB5, 0x38, 0xC6, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x34, 0xA5, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0x71, 0x8C, 0x79, 0xCE, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x55, 0xAD, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 
//	0xB2, 0x94, 0x59, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 
//	0x18, 0xC6, 0x75, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 
//	0x55, 0xA5, 0xD3, 0xAC, 0xCF, 0xBB, 0xAA, 0xCA, 0x86, 0xE1, 0x61, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x04, 0xE9, 
//	0x28, 0xD2, 0x4D, 0xC3, 0x71, 0xB4, 0x34, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x55, 0xA5, 0x34, 0xA5, 
//	0x14, 0xA5, 0x14, 0xA5, 0x55, 0xAD, 0xB6, 0xBD, 0x59, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 0x30, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 
//	0x10, 0x84, 0xF7, 0xBD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0xD3, 0x9C, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x34, 0xA5, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0x59, 0xCE, 0xB6, 0xB5, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x55, 0xA5, 
//	0x75, 0xA5, 0x34, 0xA5, 0x92, 0xAC, 0x4D, 0xC3, 0xE7, 0xD9, 0x82, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x45, 0xE1, 
//	0xAA, 0xCA, 0x10, 0xB4, 0xF3, 0xA4, 0x75, 0xA5, 0x75, 0xA5, 0x55, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0x75, 0xAD, 0x18, 0xC6, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x79, 0xCE, 0xB2, 0x94, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x75, 0xAD, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 
//	0x59, 0xCE, 0x51, 0x8C, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xD7, 0xBD, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x38, 0xC6, 0x75, 0xB5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 
//	0x55, 0xA5, 0x75, 0xA5, 0x55, 0xA5, 0x92, 0xAC, 0x2C, 0xC3, 0x86, 0xE1, 0x20, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xC3, 0xE8, 0x69, 0xD2, 
//	0x10, 0xB4, 0x14, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 
//	0xD7, 0xBD, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x14, 0xA5, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x14, 0xA5, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x18, 0xC6, 0x30, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 
//	0x71, 0x8C, 0x59, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0x18, 0xC6, 0x55, 0xAD, 0xF3, 0xA4, 
//	0x14, 0xA5, 0x34, 0xA5, 0x75, 0xA5, 0x75, 0xA5, 0xD3, 0xAC, 0x6D, 0xC3, 0xC7, 0xD9, 0x41, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xE3, 0xE8, 0xAA, 0xCA, 0x51, 0xB4, 
//	0x34, 0xA5, 0x75, 0xA5, 0x55, 0xA5, 0x34, 0xA5, 0xF3, 0xA4, 0x14, 0xA5, 0xB6, 0xB5, 0x59, 0xCE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xB6, 0xB5, 0x10, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 
//	0xB2, 0x94, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xD7, 0xBD, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0xD3, 0x9C, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0xF7, 0xBD, 
//	0x55, 0xAD, 0xF3, 0xA4, 0x14, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 0x55, 0xA5, 0x51, 0xB4, 0x8A, 0xD2, 
//	0x82, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0xA6, 0xE1, 0x8E, 0xBB, 0xF3, 0xA4, 0x75, 0xA5, 
//	0x55, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0xB6, 0xB5, 0x59, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x38, 0xC6, 0x51, 0x8C, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0x51, 0x8C, 0x79, 0xCE, 0x1C, 0xE7, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x34, 0xA5, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0x18, 0xC6, 0x55, 0xAD, 0xF3, 0xA4, 0x14, 0xA5, 0x55, 0xA5, 0x75, 0xA5, 0x34, 0xA5, 
//	0xCF, 0xBB, 0xC7, 0xD9, 0x20, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0xC3, 0xE8, 0xEB, 0xCA, 0xB2, 0xAC, 0x75, 0x9D, 0x55, 0xA5, 0x34, 0xA5, 
//	0x14, 0xA5, 0x14, 0xA5, 0xB6, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x9A, 0xD6, 0xFB, 0xDE, 0x79, 0xCE, 0x92, 0x94, 0xAE, 0x73, 
//	0x10, 0x84, 0xCF, 0x7B, 0x30, 0x84, 0x38, 0xC6, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x55, 0xAD, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0x75, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x38, 0xC6, 0x55, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x55, 0xA5, 
//	0x75, 0xA5, 0x14, 0xA5, 0xAE, 0xBB, 0x65, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x82, 0xF0, 0x8A, 0xD2, 0x92, 0xAC, 0x55, 0xA5, 0x55, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0xB6, 0xB5, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xD3, 0x9C, 0xAE, 0x73, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 
//	0x18, 0xC6, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x34, 0xA5, 
//	0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xD7, 0xBD, 0x1C, 0xE7, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xB6, 0xB5, 0xF3, 0x9C, 
//	0x14, 0xA5, 0x34, 0xA5, 0x75, 0xA5, 0x34, 0xA5, 0x8E, 0xBB, 0x24, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x61, 0xF0, 0x69, 0xD2, 
//	0x92, 0xAC, 0x75, 0x9D, 0x75, 0xA5, 0x34, 0xA5, 0xF3, 0xA4, 0x34, 0xA5, 0xF7, 0xBD, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x34, 0xA5, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xF7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0x18, 0xC6, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x79, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0xCF, 0xBB, 0x65, 0xE1, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x41, 0xF0, 0x8A, 0xD2, 0xB2, 0xAC, 0x75, 0x9D, 
//	0x55, 0xA5, 0x34, 0xA5, 0xF3, 0xA4, 0x55, 0xAD, 0x38, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x55, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xD7, 0xBD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0x10, 0x84, 
//	0xCF, 0x7B, 0x30, 0x84, 0x18, 0xC6, 0xFB, 0xDE, 0x9A, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x96, 0xB5, 0xF3, 0xA4, 
//	0x75, 0xA5, 0x92, 0xAC, 0xC3, 0xE8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x82, 0xF0, 0x0C, 0xCB, 0x14, 0xA5, 0x75, 0xA5, 0x55, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0xB6, 0xB5, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 
//	0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x34, 0xA5, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x30, 0x84, 0x38, 0xC6, 0xFB, 0xDE, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x75, 0xA5, 0x0C, 0xC3, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x24, 0xE9, 0xCF, 0xBB, 0x55, 0xA5, 0x75, 0xA5, 0x34, 0xA5, 0xF3, 0xA4, 0x55, 0xAD, 0x38, 0xC6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0x1C, 0xE7, 0x75, 0xAD, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xF7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x55, 0xAD, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x30, 0x84, 
//	0x59, 0xCE, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xD7, 0xBD, 
//	0xD3, 0xA4, 0x75, 0xA5, 0xF3, 0xA4, 0x45, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x08, 0xDA, 0x92, 0xAC, 
//	0x75, 0xA5, 0x55, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0xB6, 0xB5, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0x18, 0xC6, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x75, 0xAD, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x59, 0xCE, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x34, 0xAD, 0x14, 0xA5, 0x75, 0xA5, 0xAE, 0xBB, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0x82, 0xF0, 0x2C, 0xC3, 0x34, 0xA5, 0x75, 0xA5, 0x34, 0xA5, 
//	0xF3, 0xA4, 0x55, 0xAD, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x1C, 0xE7, 0xB6, 0xB5, 0xAE, 0x73, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x38, 0xC6, 0xFB, 0xDE, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x18, 0xBE, 0xF3, 0xA4, 0x55, 0xA5, 0x14, 0xA5, 0xE7, 0xD9, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x86, 0xE1, 0x71, 0xAC, 0x75, 0x9D, 0x55, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0xF7, 0xBD, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x59, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xF7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0x10, 0x84, 0x18, 0xC6, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x75, 0xAD, 0xF3, 0xA4, 0x96, 0xA5, 
//	0x30, 0xB4, 0x20, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0x61, 0xF0, 0x6D, 0xC3, 
//	0x55, 0xA5, 0x75, 0xA5, 0x14, 0xA5, 0xF3, 0xA4, 0x96, 0xB5, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x55, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 
//	0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x38, 0xC6, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x38, 0xC6, 0xF3, 0xA4, 0x34, 0xA5, 0x55, 0xA5, 0xAA, 0xCA, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x28, 0xD2, 0xD3, 0xAC, 0x75, 0xA5, 0x34, 0xA5, 
//	0xF3, 0xA4, 0x75, 0xAD, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x34, 0xA5, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0xB2, 0x94, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 0x30, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xB6, 0xB5, 
//	0xFB, 0xDE, 0x9A, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xB6, 0xB5, 0xD3, 0xA4, 
//	0x75, 0xA5, 0x92, 0xAC, 0xC3, 0xE8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 
//	0x00, 0xF8, 0x04, 0xE9, 0x30, 0xB4, 0x75, 0x9D, 0x55, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x38, 0xC6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD3, 0x9C, 0xAE, 0x73, 0x10, 0x84, 
//	0xAE, 0x73, 0xF3, 0x9C, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0x92, 0x94, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x55, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x14, 0xA5, 0x75, 0xA5, 0x2C, 0xC3, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x61, 0xF0, 0x6D, 0xC3, 
//	0x75, 0x9D, 0x55, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x18, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0x92, 0x94, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0x55, 0xAD, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x14, 0xA5, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xD7, 0xBD, 
//	0xD3, 0xA4, 0x75, 0xA5, 0xF3, 0xA4, 0x65, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x8A, 0xD2, 0x34, 0xA5, 0x75, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0xD7, 0xBD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x51, 0x8C, 
//	0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 0xF7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x96, 0xB5, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 
//	0xB2, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x96, 0xA5, 0xCF, 0xBB, 
//	0x20, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 
//	0x00, 0xF8, 0xC7, 0xD9, 0xD3, 0xAC, 0x75, 0xA5, 0x34, 0xA5, 0xF3, 0xA4, 0xB6, 0xB5, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 0x59, 0xCE, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 
//	0x59, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x18, 0xC6, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x18, 0xC6, 0xF3, 0xA4, 0x55, 0xA5, 0x34, 0xA5, 0x28, 0xDA, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0x65, 0xE1, 0xB2, 0xAC, 
//	0x75, 0x9D, 0x34, 0xA5, 0xF3, 0x9C, 0xB6, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xD7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0x30, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x18, 0xC6, 
//	0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x75, 0xAD, 0xF3, 0xA4, 0x96, 0xA5, 
//	0x51, 0xB4, 0x61, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0xE3, 0xE8, 0x51, 0xB4, 0x75, 0x9D, 0x34, 0xA5, 0xF3, 0xA4, 
//	0x96, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x55, 0xAD, 0xAE, 0x73, 0x10, 0x84, 
//	0xAE, 0x73, 0xF3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xD3, 0x9C, 0xAE, 0x73, 
//	0x10, 0x84, 0xCF, 0x7B, 0x96, 0xB5, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0x34, 0xA5, 0x55, 0xA5, 0xCB, 0xCA, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 
//	0x82, 0xF0, 0x10, 0xB4, 0x75, 0x9D, 0x34, 0xA5, 0xF3, 0xA4, 0x96, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xD3, 0x9C, 0xAE, 0x73, 0xEF, 0x7B, 0xAE, 0x73, 0xB6, 0xB5, 0x1C, 0xE7, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x1C, 0xE7, 0x96, 0xB5, 0xAE, 0x73, 0x10, 0x84, 0xAE, 0x73, 0x14, 0xA5, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xB6, 0xB5, 0xD3, 0xA4, 
//	0x75, 0xA5, 0xB2, 0xAC, 0xE3, 0xE8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0x82, 0xF0, 0xEF, 0xBB, 0x75, 0x9D, 
//	0x34, 0xA5, 0xF3, 0xA4, 0x96, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x51, 0x8C, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x59, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0x71, 0x8C, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x75, 0xA5, 0x4D, 0xC3, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x61, 0xF0, 0xEF, 0xBB, 0x75, 0x9D, 0x34, 0xA5, 0xF3, 0xA4, 0xB6, 0xB5, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 0xF7, 0xBD, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0x71, 0x8C, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 
//	0xF3, 0xA4, 0x75, 0xA5, 0x14, 0xA5, 0xA6, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x61, 0xF0, 
//	0xEF, 0xBB, 0x75, 0x9D, 0x34, 0xA5, 0xF3, 0xA4, 0xD7, 0xBD, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x55, 0xAD, 0xAE, 0x73, 0x10, 0x84, 0xAE, 0x73, 0x55, 0xAD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x55, 0xAD, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x75, 0xAD, 
//	0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0xF3, 0xA4, 0x96, 0xA5, 0xEF, 0xBB, 
//	0x20, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x82, 0xF0, 0x30, 0xB4, 0x75, 0x9D, 0x34, 0xA5, 
//	0xF3, 0xA4, 0xF7, 0xBD, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0x38, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x38, 0xC6, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x18, 0xC6, 0xF3, 0xA4, 0x55, 0xA5, 0x34, 0xA5, 0x49, 0xD2, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0xC3, 0xF0, 0x71, 0xB4, 0x75, 0x9D, 0x14, 0xA5, 0x14, 0xA5, 0x38, 0xC6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x59, 0xCE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x96, 0xAD, 0xF3, 0xA4, 0x96, 0xA5, 
//	0x51, 0xB4, 0x82, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x04, 0xE9, 0xB2, 0xAC, 
//	0x75, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xAE, 0x73, 0x75, 0xAD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x75, 0xAD, 0xAE, 0x73, 0x10, 0x84, 
//	0xCF, 0x7B, 0x75, 0xAD, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x75, 0xA5, 0xEB, 0xCA, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0x86, 0xE1, 0x14, 0xA5, 0x75, 0xA5, 0x14, 0xA5, 0x55, 0xAD, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x79, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xD7, 0xB5, 0xD3, 0xA4, 
//	0x75, 0xA5, 0xD3, 0xAC, 0x24, 0xE9, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 
//	0x28, 0xD2, 0x55, 0xA5, 0x55, 0xA5, 0xF3, 0xA4, 0x75, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0xB2, 0x94, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xD3, 0x9C, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0x38, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x96, 0xA5, 0x6D, 0xBB, 0x20, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0xEB, 0xCA, 0x75, 0x9D, 0x34, 0xA5, 
//	0xF3, 0xA4, 0xD7, 0xBD, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 0x55, 0xAD, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 
//	0xD7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xF7, 0xBD, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x34, 0xA5, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 
//	0xF3, 0xA4, 0x55, 0xA5, 0x14, 0xA5, 0xC7, 0xD9, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x20, 0xF8, 0x00, 0xF8, 0xAE, 0xBB, 0x75, 0x9D, 0x34, 0xA5, 0x14, 0xA5, 0x38, 0xC6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x75, 0xAD, 0xF3, 0xA4, 0x96, 0xA5, 0xEF, 0xB3, 
//	0x41, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xA2, 0xF0, 0x92, 0xAC, 
//	0x75, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xF7, 0xBD, 0xCF, 0x7B, 0x10, 0x84, 
//	0xAE, 0x73, 0x75, 0xAD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x96, 0xB5, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x96, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x38, 0xC6, 0xF3, 0xA4, 0x34, 0xA5, 0x55, 0xA5, 0x69, 0xD2, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x86, 0xE1, 0x14, 0xA5, 0x55, 0xA5, 0xF3, 0xA4, 0x75, 0xAD, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xD3, 0x9C, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0x30, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x96, 0xB5, 0xD3, 0xA4, 0x96, 0xA5, 
//	0x71, 0xB4, 0xA2, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x69, 0xD2, 0x55, 0xA5, 0x55, 0xA5, 0xF3, 0xA4, 0xF7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xAE, 0x73, 0xF3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x75, 0xAD, 0xAE, 0x73, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x14, 0xA5, 0x75, 0xA5, 0x0C, 0xC3, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0xCF, 0xBB, 0x75, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x34, 0xA5, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xD7, 0xBD, 0xF3, 0xA4, 
//	0x75, 0xA5, 0xD3, 0xAC, 0x45, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0xE3, 0xE8, 0xD3, 0xAC, 0x75, 0xA5, 0x14, 0xA5, 0x75, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 
//	0x10, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0xF3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x55, 0xAD, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0x38, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x55, 0xAD, 0xF3, 0xA4, 0x96, 0x9D, 0x8E, 0xBB, 0x20, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x28, 0xD2, 0x55, 0xA5, 
//	0x55, 0xA5, 0xF3, 0xA4, 0xF7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x55, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0x38, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 
//	0x10, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x18, 0xBE, 
//	0xF3, 0xA4, 0x55, 0xA5, 0x14, 0xA5, 0xE7, 0xD9, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xAE, 0xBB, 0x75, 0x9D, 0x34, 0xA5, 0x14, 0xA5, 0x79, 0xCE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x34, 0xA5, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x75, 0xAD, 0xD3, 0xA4, 0x96, 0x9D, 0x10, 0xB4, 
//	0x41, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xE3, 0xE8, 
//	0xD3, 0xAC, 0x55, 0xA5, 0xF3, 0xA4, 0x96, 0xB5, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x55, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0x38, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0x30, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xD7, 0xBD, 0x75, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x38, 0xC6, 0xF3, 0xA4, 0x34, 0xA5, 0x55, 0xA5, 0x8A, 0xD2, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0x69, 0xD2, 0x55, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 
//	0x38, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x9A, 0xD6, 0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x96, 0xB5, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x17, 0xC6, 
//	0xF3, 0x9C, 0x14, 0xA5, 0xF4, 0x9C, 0x75, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xB6, 0xB5, 0xD3, 0xA4, 0x96, 0xA5, 
//	0x92, 0xAC, 0xC3, 0xE8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xC3, 0xE8, 
//	0x0C, 0xCB, 0x34, 0xA5, 0x55, 0xA5, 0xF3, 0xA4, 0x75, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x55, 0xAD, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0x79, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xB2, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 
//	0x14, 0xA5, 0xB6, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x79, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x75, 0xA5, 0x2C, 0xC3, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x82, 0xF0, 0x28, 0xD2, 0x92, 0xAC, 0xB6, 0x9D, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0x34, 0xA5, 0x1C, 0xE7, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xD7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0xF4, 0x9C, 
//	0x34, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x34, 0xA5, 0xD7, 0xBD, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD7, 0xBD, 0xD3, 0xA4, 
//	0x75, 0xA5, 0xF3, 0xAC, 0x65, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x41, 0xF8, 0xA6, 0xE1, 0xEF, 0xBB, 0x96, 0x9D, 0x75, 0xA5, 
//	0xF3, 0xA4, 0x14, 0xA5, 0x55, 0xAD, 0xF7, 0xBD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x14, 0xA5, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x71, 0x8C, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x9A, 0xD6, 0x34, 0xA5, 0x34, 0xA5, 0x54, 0xAD, 0xF8, 0x7B, 0xBB, 0x52, 0x96, 0x94, 
//	0x54, 0xAD, 0x74, 0xAD, 0x14, 0xA5, 0xF4, 0x9C, 0x55, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x55, 0xAD, 0xF3, 0xA4, 0x96, 0x9D, 0xAE, 0xBB, 0x41, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x04, 0xE9, 0x4D, 0xC3, 
//	0x55, 0xA5, 0x96, 0x9D, 0xF3, 0xA4, 0xF3, 0xA4, 0x34, 0xA5, 0xB6, 0xB5, 0x79, 0xCE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x96, 0xB5, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x59, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xB6, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD7, 0xBD, 0xF4, 0x9C, 0x54, 0xAD, 
//	0x14, 0xA5, 0x1D, 0x42, 0x1F, 0x21, 0xDE, 0x39, 0x79, 0x6B, 0xD5, 0x9C, 0x54, 0xAD, 0x54, 0xAD, 
//	0x14, 0xA5, 0xF4, 0x9C, 0x76, 0xAD, 0x58, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x18, 0xC6, 
//	0xF3, 0xA4, 0x55, 0xA5, 0x34, 0xA5, 0x28, 0xDA, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0xC3, 0xF0, 0xAA, 0xCA, 0xF3, 0xAC, 0xB6, 0x9D, 0x34, 0xA5, 0xF3, 0xA4, 0x14, 0xA5, 0x96, 0xB5, 
//	0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x34, 0xA5, 0xAE, 0x73, 0xEF, 0x7B, 0x30, 0x84, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x34, 0xA5, 0x34, 0xA5, 0x53, 0xAD, 0xB9, 0x73, 0x5F, 0x29, 0xDF, 0x39, 0x7F, 0x29, 
//	0x3F, 0x21, 0x3D, 0x42, 0xD8, 0x7B, 0x14, 0xA5, 0x74, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 0x14, 0xA5, 
//	0xB6, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x96, 0xAD, 0xD3, 0xA4, 0x96, 0xA5, 0x30, 0xB4, 
//	0x61, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x82, 0xF0, 0x08, 0xDA, 0x71, 0xB4, 0xB6, 0x9D, 0x55, 0xA5, 0xD3, 0xA4, 
//	0x14, 0xA5, 0x75, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0x18, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0x30, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0x14, 0xA5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD7, 0xBD, 0x14, 0xA5, 0x54, 0xAD, 0xF5, 0x9C, 
//	0x1E, 0x42, 0x7F, 0x29, 0x9F, 0x31, 0xBF, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0x5F, 0x29, 0x9C, 0x52, 
//	0x37, 0x84, 0x34, 0xA5, 0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x34, 0xA5, 0xF7, 0xBD, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xC6, 0x14, 0xA5, 0x34, 0xA5, 0x75, 0xA5, 0xAA, 0xCA, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x86, 0xE1, 0xCF, 0xBB, 0x96, 0x9D, 
//	0x75, 0x9D, 0xF3, 0xA4, 0xF3, 0xA4, 0x55, 0xA5, 0xD7, 0xBD, 0x9A, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0x51, 0x8C, 0xEF, 0x7B, 0xAE, 0x73, 0x14, 0xA5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xD7, 0xBD, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 
//	0x34, 0xA5, 0x34, 0xA5, 0x53, 0xAD, 0xB9, 0x73, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0x9F, 0x31, 0x3F, 0x21, 0x9F, 0x31, 0x1A, 0x63, 0x96, 0x94, 0x54, 0xAD, 
//	0x54, 0xAD, 0x14, 0xA5, 0xF4, 0x9C, 0x55, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xB6, 0xB5, 0xD3, 0xA4, 0x96, 0xA5, 
//	0xB2, 0xAC, 0xE3, 0xE8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x04, 0xE9, 
//	0x2C, 0xC3, 0x34, 0xA5, 0xB6, 0x9D, 0x14, 0xA5, 0xF3, 0xA4, 0x34, 0xA5, 0xB6, 0xB5, 0x79, 0xCE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x34, 0xA5, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x10, 0x84, 0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xB2, 0x94, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0xF4, 0x9C, 0x54, 0xAD, 0x14, 0xA5, 0x1D, 0x42, 
//	0x7F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 
//	0x7F, 0x29, 0x3F, 0x21, 0xDE, 0x39, 0x99, 0x73, 0xF5, 0x9C, 0x74, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 
//	0xF4, 0x9C, 0x96, 0xB5, 0x59, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x79, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x96, 0x9D, 0x4D, 0xC3, 0x20, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0xA2, 0xF0, 0x8A, 0xD2, 0xD3, 0xAC, 0xB6, 0x9D, 0x34, 0xA5, 0xD3, 0xA4, 0x14, 0xA5, 
//	0x96, 0xAD, 0x38, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x38, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0xB6, 0xB5, 0x1C, 0xE7, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0x96, 0xB5, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 
//	0x14, 0xA5, 0x54, 0xAD, 0xD8, 0x7B, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 
//	0x3D, 0x42, 0xF8, 0x7B, 0x14, 0xA5, 0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x14, 0xA5, 0xD6, 0xBD, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0xD3, 0xA4, 
//	0x55, 0xA5, 0x14, 0xA5, 0xA6, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x61, 0xF0, 0xE7, 0xD9, 0x51, 0xB4, 0xB6, 0x9D, 0x75, 0xA5, 
//	0xF3, 0xA4, 0xF3, 0xA4, 0x75, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xB2, 0x94, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xB2, 0x94, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x96, 0xB5, 0xAE, 0x73, 
//	0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x18, 0xC6, 0x14, 0xA5, 0x54, 0xAD, 0x14, 0xA5, 0x5D, 0x4A, 0x5F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0x5F, 0x29, 0xBB, 0x52, 0x56, 0x8C, 
//	0x34, 0xA5, 0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x35, 0xA5, 0xF7, 0xBD, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0xF3, 0xA4, 0x96, 0x9D, 0xCF, 0xBB, 0x41, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x65, 0xE1, 0x8E, 0xBB, 
//	0x75, 0xA5, 0x96, 0x9D, 0xF3, 0xA4, 0xF3, 0xA4, 0x34, 0xA5, 0xD7, 0xBD, 0x9A, 0xD6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x75, 0xAD, 0x14, 0xA5, 
//	0x54, 0xAD, 0x37, 0x84, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0xBF, 0x31, 0x9F, 0x31, 0x3F, 0x21, 0x9F, 0x31, 0x3A, 0x63, 0xB5, 0x94, 0x54, 0xAD, 0x54, 0xAD, 
//	0x14, 0xA5, 0xF4, 0x9C, 0x75, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x18, 0xC6, 
//	0xF3, 0xA4, 0x34, 0xA5, 0x55, 0xA5, 0x49, 0xD2, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0xE3, 0xE8, 0xEB, 0xCA, 0x34, 0xA5, 0xB6, 0x9D, 0x14, 0xA5, 0xD3, 0xA4, 0x14, 0xA5, 0xB6, 0xB5, 
//	0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x10, 0x84, 
//	0xEF, 0x7B, 0xAE, 0x73, 0x96, 0xB5, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xB6, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x54, 0xAD, 0xDB, 0x5A, 0x5F, 0x29, 0xBF, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 
//	0x3F, 0x21, 0xFE, 0x39, 0xB9, 0x73, 0xF5, 0x9C, 0x74, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 0x14, 0xA5, 
//	0x96, 0xB5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x96, 0xB5, 0xD3, 0xA4, 0x96, 0xA5, 0x51, 0xB4, 
//	0xA2, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0xA2, 0xF0, 0x49, 0xD2, 0xB2, 0xAC, 0xB6, 0x9D, 0x55, 0xA5, 0xD3, 0xA4, 
//	0x14, 0xA5, 0x96, 0xAD, 0x38, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xD3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0x96, 0xB5, 0xAE, 0x73, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xB6, 0xB5, 0xF4, 0x9C, 0x54, 0xAD, 
//	0xB5, 0x94, 0xBF, 0x31, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0x5F, 0x29, 0x7C, 0x4A, 
//	0x17, 0x84, 0x34, 0xA5, 0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x34, 0xA5, 0xD7, 0xBD, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xCE, 0x14, 0xA5, 0x14, 0xA5, 0x75, 0xA5, 0xEB, 0xCA, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x41, 0xF8, 0xC7, 0xD9, 0x10, 0xB4, 0x96, 0x9D, 
//	0x75, 0xA5, 0xF3, 0xA4, 0xF3, 0xA4, 0x55, 0xAD, 0xF7, 0xBD, 0xBA, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xB6, 0xB5, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xD3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x55, 0xAD, 0x34, 0xA5, 0x54, 0xAD, 0x99, 0x73, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0xBF, 0x31, 0x3F, 0x21, 0x7F, 0x29, 0xDB, 0x5A, 0x76, 0x8C, 0x54, 0xAD, 
//	0x74, 0xAD, 0x14, 0xA5, 0xF4, 0x9C, 0x55, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xDE, 0xD7, 0xB5, 0xD3, 0xA4, 0x75, 0xA5, 
//	0xB2, 0xAC, 0x24, 0xE9, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x45, 0xE1, 
//	0x6D, 0xC3, 0x55, 0xA5, 0x96, 0x9D, 0x14, 0xA5, 0xF3, 0xA4, 0x34, 0xA5, 0xD7, 0xB5, 0x9A, 0xD6, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0x96, 0xB5, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xB6, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 
//	0x5D, 0x4A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 
//	0x9F, 0x31, 0x3F, 0x21, 0xBE, 0x31, 0x5A, 0x6B, 0xB5, 0x94, 0x54, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 
//	0xF4, 0x9C, 0x75, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x79, 0xCE, 0x34, 0xA5, 0xF3, 0xA4, 0x96, 0x9D, 0x6D, 0xC3, 0x20, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0xE3, 0xE8, 0xCB, 0xCA, 0x14, 0xA5, 0xB6, 0x9D, 0x34, 0xA5, 0xD3, 0xA4, 0x14, 0xA5, 
//	0x96, 0xB5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xD7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x96, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0x56, 0x8C, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 
//	0x1D, 0x42, 0xB8, 0x73, 0xF5, 0x9C, 0x74, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 0x14, 0xA5, 0xB6, 0xB5, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0xF3, 0xA4, 
//	0x55, 0xA5, 0x14, 0xA5, 0xC7, 0xD9, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x82, 0xF0, 0x28, 0xD2, 0x71, 0xAC, 0xB6, 0x9D, 0x55, 0xA5, 
//	0xD3, 0xA4, 0x14, 0xA5, 0x75, 0xAD, 0x38, 0xC6, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 0xEF, 0x7B, 0x30, 0x84, 
//	0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x14, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0x3A, 0x63, 
//	0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0x5F, 0x29, 0x9C, 0x52, 0x37, 0x84, 
//	0x34, 0xA5, 0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x34, 0xA5, 0xF7, 0xBD, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x75, 0xAD, 0xF3, 0xA4, 0x96, 0x9D, 0xEF, 0xBB, 0x61, 0xF0, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x41, 0xF8, 0xA6, 0xE1, 0xEF, 0xBB, 
//	0x96, 0x9D, 0x96, 0x9D, 0xF3, 0xA4, 0xF3, 0xA4, 0x55, 0xAD, 0xF7, 0xBD, 0x9A, 0xD6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x38, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x51, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0x34, 0xA5, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x18, 0xC6, 
//	0xF4, 0x9C, 0x54, 0xAD, 0xF5, 0x9C, 0x1E, 0x42, 0x7F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0xBF, 0x31, 0x9F, 0x31, 0x3F, 0x21, 0x9F, 0x31, 0xFA, 0x5A, 0x96, 0x94, 0x54, 0xAD, 0x74, 0xAD, 
//	0x14, 0xA5, 0xF4, 0x9C, 0x55, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 
//	0xF3, 0xA4, 0x34, 0xA5, 0x55, 0xA5, 0x69, 0xD2, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x24, 0xE9, 0x4D, 0xC3, 0x55, 0xA5, 0xB6, 0x9D, 0x14, 0xA5, 0xD3, 0xA4, 0x34, 0xA5, 0xB6, 0xB5, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x34, 0xA5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xB6, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0x57, 0x8C, 0x7F, 0x29, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 
//	0x3F, 0x21, 0xDE, 0x39, 0x79, 0x6B, 0xD5, 0x9C, 0x74, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 0xF4, 0x9C, 
//	0x96, 0xB5, 0x59, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x96, 0xB5, 0xD3, 0xA4, 0x96, 0x9D, 0x71, 0xB4, 
//	0xC3, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0xC3, 0xF0, 0xAA, 0xCA, 0xD3, 0xAC, 0xB6, 0x9D, 0x34, 0xA5, 0xD3, 0xA4, 
//	0x14, 0xA5, 0x96, 0xB5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xFB, 0xDE, 0x34, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xB6, 0xB5, 0xAE, 0x73, 0xEF, 0x7B, 0x30, 0x84, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 
//	0x14, 0xA5, 0x54, 0xAD, 0x5A, 0x6B, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 0x3D, 0x42, 
//	0xF8, 0x7B, 0x14, 0xA5, 0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x14, 0xA5, 0xB6, 0xB5, 0x79, 0xCE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x96, 0x9D, 0x0C, 0xCB, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x61, 0xF0, 0x08, 0xDA, 0x51, 0xB4, 0xB6, 0x9D, 
//	0x75, 0xA5, 0xF3, 0xA4, 0xF3, 0xA4, 0x75, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x10, 0x84, 0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x14, 0xA5, 
//	0xAE, 0x73, 0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x5D, 0x4A, 0x7F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0x5F, 0x29, 0xBB, 0x52, 0x57, 0x8C, 0x54, 0xAD, 
//	0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x55, 0xAD, 0xF7, 0xBD, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xD7, 0xBD, 0xD3, 0xA4, 0x75, 0xA5, 
//	0xD3, 0xAC, 0x45, 0xE1, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 0x86, 0xE1, 
//	0xAE, 0xBB, 0x75, 0xA5, 0x96, 0x9D, 0xF3, 0xA4, 0xF3, 0xA4, 0x55, 0xAD, 0xD7, 0xBD, 0x9A, 0xD6, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0x34, 0xA5, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD7, 0xBD, 0x14, 0xA5, 
//	0x54, 0xAD, 0x96, 0x94, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 
//	0x9F, 0x31, 0x3F, 0x21, 0xBF, 0x31, 0x1A, 0x63, 0x96, 0x94, 0x74, 0xAD, 0x74, 0xAD, 0x14, 0xA5, 
//	0xF4, 0x9C, 0x75, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x79, 0xCE, 0x55, 0xAD, 0xF3, 0xA4, 0x96, 0x9D, 0x8E, 0xBB, 0x41, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x04, 0xE9, 0x0C, 0xC3, 0x34, 0xA5, 0xB6, 0x9D, 0x14, 0xA5, 0xD3, 0xA4, 0x34, 0xA5, 
//	0xB6, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 
//	0xAE, 0x73, 0x55, 0xAD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 0x10, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0x75, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0xB8, 0x73, 0x5F, 0x29, 0xBF, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 
//	0xFE, 0x39, 0x99, 0x73, 0xF5, 0x9C, 0x73, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 0x14, 0xA5, 0x96, 0xB5, 
//	0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0xF3, 0xA4, 
//	0x55, 0xA5, 0x34, 0xA5, 0xE7, 0xD9, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xA2, 0xF0, 0x8A, 0xD2, 0xB2, 0xAC, 0xB6, 0x9D, 0x55, 0xA5, 
//	0xD3, 0xA4, 0x14, 0xA5, 0x96, 0xAD, 0x38, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xF3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xF7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x34, 0xA5, 0x34, 0xA5, 
//	0x54, 0xAD, 0xDB, 0x5A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0x5F, 0x29, 0x5C, 0x4A, 0xF8, 0x7B, 
//	0x34, 0xA5, 0x74, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x34, 0xA5, 0xD7, 0xBD, 0x79, 0xCE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x75, 0xAD, 0xD3, 0xA4, 0x96, 0x9D, 0x10, 0xB4, 0x82, 0xF0, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x61, 0xF8, 0xE7, 0xD9, 0x30, 0xB4, 
//	0x96, 0x9D, 0x75, 0xA5, 0xF3, 0xA4, 0xF3, 0xA4, 0x75, 0xAD, 0x18, 0xBE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x30, 0x84, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x75, 0xAD, 0xAE, 0x73, 
//	0xCF, 0x7B, 0x71, 0x8C, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0x34, 0xA5, 0xF5, 0x9C, 0x1E, 0x42, 0x7F, 0x29, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0xBF, 0x31, 0x9F, 0x31, 0x3F, 0x21, 0x7F, 0x29, 0xDB, 0x5A, 0x56, 0x8C, 0x54, 0xAD, 0x74, 0xAD, 
//	0x14, 0xA5, 0xD4, 0x9C, 0x55, 0xAD, 0x17, 0xC6, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 
//	0x14, 0xA5, 0x34, 0xA5, 0x75, 0xA5, 0x8A, 0xD2, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x65, 0xE1, 0x8E, 0xBB, 0x75, 0xA5, 0x96, 0x9D, 0x14, 0xA5, 0xD3, 0xA4, 0x34, 0xA5, 0xD7, 0xBD, 
//	0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x18, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xF3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD7, 0xBD, 0x14, 0xA5, 0x54, 0xAD, 
//	0x76, 0x8C, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 
//	0x3F, 0x21, 0xBE, 0x31, 0x3A, 0x63, 0xB6, 0x94, 0x74, 0xAD, 0x54, 0xAD, 0x14, 0xA5, 0xF4, 0x9C, 
//	0x75, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xB6, 0xB5, 0xD3, 0xA4, 0x96, 0xA5, 0x92, 0xAC, 
//	0xE3, 0xE8, 0x00, 0xF8, 0x20, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x04, 0xE9, 0xEB, 0xCA, 0x14, 0xA5, 0xB6, 0x9D, 0x34, 0xA5, 0xD3, 0xA4, 
//	0x14, 0xA5, 0xB6, 0xB5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x10, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xD7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0x71, 0x8C, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x55, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0x96, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0xB9, 0x73, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 0x1D, 0x42, 
//	0xB9, 0x73, 0xF5, 0x9C, 0x73, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 0x14, 0xA5, 0xB6, 0xB5, 0x59, 0xCE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xCE, 0x34, 0xA5, 0xF3, 0xA4, 0x96, 0x9D, 0x0C, 0xC3, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x20, 0xF8, 0xA2, 0xE0, 0x04, 0xD9, 0x65, 0xC9, 0xE7, 0xB9, 0x28, 0xB2, 0x28, 0xB2, 0x08, 0xBA, 
//	0xE7, 0xB9, 0x65, 0xC9, 0x24, 0xD9, 0xA2, 0xE0, 0x20, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xA2, 0xF0, 0x69, 0xD2, 0x92, 0xAC, 0xB6, 0x9D, 
//	0x55, 0xA5, 0xD3, 0xA4, 0x14, 0xA5, 0x75, 0xAD, 0x38, 0xC6, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0x71, 0x8C, 0xCF, 0x7B, 0xAE, 0x73, 0x55, 0xAD, 0x1C, 0xE7, 
//	0xFB, 0xDE, 0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 
//	0xFB, 0x5A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0x5F, 0x29, 0x7C, 0x4A, 0x17, 0x84, 0x34, 0xA5, 
//	0x73, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x34, 0xA5, 0xD7, 0xBD, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xD7, 0xBD, 0xD3, 0xA4, 0x75, 0xA5, 
//	0xF3, 0xAC, 0xA6, 0xE1, 0x61, 0xE8, 0x86, 0xC9, 0x69, 0xAA, 0x4D, 0x93, 0xEF, 0x83, 0x30, 0x7C, 
//	0x51, 0x74, 0x51, 0x74, 0x51, 0x74, 0x51, 0x74, 0x51, 0x74, 0x30, 0x7C, 0xEF, 0x83, 0x6D, 0x93, 
//	0x8A, 0xAA, 0x86, 0xC9, 0xA2, 0xE8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x41, 0xF8, 0xC7, 0xD9, 
//	0x10, 0xB4, 0x96, 0x9D, 0x96, 0xA5, 0xF3, 0xA4, 0xF3, 0xA4, 0x55, 0xAD, 0xF7, 0xBD, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xF3, 0x9C, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0x1C, 0xE7, 0x18, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x79, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x5D, 0x4A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 
//	0x9F, 0x31, 0x3F, 0x21, 0x9F, 0x31, 0xFB, 0x5A, 0x76, 0x8C, 0x54, 0xAD, 0x74, 0xAD, 0x14, 0xA5, 
//	0xF4, 0x9C, 0x55, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x79, 0xCE, 0x55, 0xAD, 0x14, 0xA5, 0x34, 0x9D, 0xAE, 0x9B, 0xEB, 0x9A, 0x30, 0x7C, 
//	0x71, 0x74, 0x30, 0x74, 0xEF, 0x73, 0xCF, 0x7B, 0xAE, 0x7B, 0xAE, 0x7B, 0xAE, 0x7B, 0xAE, 0x7B, 
//	0xAE, 0x7B, 0xCF, 0x7B, 0xEF, 0x73, 0x30, 0x74, 0x51, 0x74, 0x30, 0x7C, 0x4D, 0x93, 0xE7, 0xB9, 
//	0xA2, 0xE8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x45, 0xE1, 0x6D, 0xC3, 0x55, 0xA5, 0xB6, 0x9D, 0x14, 0xA5, 0xD3, 0xA4, 0x34, 0xA5, 
//	0xD7, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xBA, 0xD6, 
//	0x3C, 0xE7, 0x96, 0xB5, 0xCF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x9A, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0x54, 0xAD, 0xD5, 0x9C, 
//	0xDF, 0x39, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 
//	0xDE, 0x39, 0x59, 0x6B, 0xD5, 0x9C, 0x73, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 0xF4, 0x9C, 0x95, 0xB5, 
//	0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x38, 0xC6, 0xB2, 0x94, 
//	0x10, 0x84, 0x30, 0x74, 0x51, 0x74, 0xEF, 0x7B, 0xAE, 0x7B, 0xAE, 0x83, 0xEF, 0x83, 0x30, 0x8C, 
//	0x71, 0x8C, 0x92, 0x94, 0x92, 0x94, 0x92, 0x94, 0x71, 0x94, 0x30, 0x8C, 0xEF, 0x83, 0xAE, 0x7B, 
//	0xAE, 0x7B, 0xCF, 0x7B, 0x30, 0x74, 0x51, 0x74, 0x4D, 0x93, 0x86, 0xC9, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0xE3, 0xE8, 0xCB, 0xCA, 0xF3, 0xAC, 0xB6, 0x9D, 0x34, 0xA5, 
//	0xD3, 0xA4, 0x14, 0xA5, 0x96, 0xB5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xF7, 0xBD, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0x3C, 0xE7, 0x55, 0xAD, 0xAE, 0x73, 0xCF, 0x7B, 
//	0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xD7, 0xBD, 0xF4, 0x9C, 0x54, 0xAD, 0x57, 0x8C, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x5F, 0x29, 0x3D, 0x42, 0xD8, 0x7B, 
//	0x14, 0xA5, 0x73, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x14, 0xA5, 0xB6, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0x34, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xAE, 0x7B, 0xEF, 0x83, 
//	0x71, 0x8C, 0x14, 0x9D, 0x75, 0xAD, 0xB6, 0xB5, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xB6, 0xB5, 0x75, 0xAD, 0x14, 0x9D, 0x92, 0x94, 0xEF, 0x83, 0xAE, 0x7B, 0xCF, 0x7B, 
//	0x51, 0x74, 0x30, 0x74, 0x49, 0xAA, 0x61, 0xF0, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x82, 0xF0, 0x49, 0xD2, 0x71, 0xB4, 
//	0xB6, 0x9D, 0x75, 0xA5, 0xD3, 0xA4, 0xF3, 0xA4, 0x75, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 
//	0x1C, 0xE7, 0x14, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x96, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0xD8, 0x7B, 
//	0x5F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0xBF, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0x7F, 0x29, 0x9C, 0x52, 0x37, 0x84, 0x34, 0xA5, 0x74, 0xAD, 
//	0x34, 0xA5, 0xF4, 0x9C, 0x34, 0xA5, 0xF7, 0xBD, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x9A, 0xD6, 0xD3, 0x9C, 0xAE, 0x73, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0x92, 0x94, 0x75, 0xAD, 0xF7, 0xBD, 0x18, 0xC6, 0x18, 0xC6, 0x18, 0xC6, 
//	0x18, 0xC6, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0x18, 0xC6, 0x18, 0xC6, 0x18, 0xC6, 
//	0xF7, 0xBD, 0x75, 0xAD, 0xB2, 0x94, 0xEF, 0x7B, 0xAE, 0x7B, 0xEF, 0x7B, 0x51, 0x74, 0xCB, 0x9A, 
//	0x82, 0xE8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x00, 0xF8, 0x20, 0xF8, 
//	0xA6, 0xE1, 0xCF, 0xBB, 0x75, 0xA5, 0x96, 0x9D, 0xF3, 0xA4, 0xF3, 0xA4, 0x55, 0xAD, 0xF7, 0xBD, 
//	0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 
//	0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x34, 0xA5, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0x75, 0xAD, 0x14, 0xA5, 0x74, 0xAD, 0x5A, 0x6B, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x9F, 0x31, 
//	0x3F, 0x21, 0xBF, 0x31, 0x1A, 0x63, 0x96, 0x94, 0x74, 0xAD, 0x74, 0xAD, 0x14, 0xA5, 0xF4, 0x9C, 
//	0x75, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 0x79, 0xCE, 
//	0x92, 0x94, 0xAE, 0x73, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x34, 0xA5, 0xF7, 0xBD, 0x18, 0xC6, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0xF7, 0xBD, 0x55, 0xAD, 
//	0x30, 0x84, 0xAE, 0x7B, 0xCF, 0x83, 0x51, 0x74, 0x2C, 0x93, 0x82, 0xE8, 0x00, 0xF8, 0x20, 0xF8, 
//	0x00, 0xF8, 0x00, 0xF8, 0x24, 0xE9, 0x2C, 0xC3, 0x34, 0xA5, 0xB6, 0x9D, 0x34, 0xA5, 0xD3, 0xA4, 
//	0x34, 0xA5, 0xB6, 0xB5, 0x79, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 0xAE, 0x73, 0x96, 0xB5, 
//	0xDB, 0xDE, 0x51, 0x8C, 0xCF, 0x7B, 0xAE, 0x73, 0x96, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0xDB, 0x5A, 
//	0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 0xFE, 0x39, 
//	0x79, 0x6B, 0xD5, 0x9C, 0x73, 0xAD, 0x54, 0xAD, 0xF4, 0x9C, 0xF4, 0x9C, 0x96, 0xB5, 0x59, 0xCE, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 0xD3, 0x9C, 0xAE, 0x73, 0xEF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 
//	0x96, 0xB5, 0x38, 0xC6, 0xF7, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0x38, 0xC6, 0xB6, 0xB5, 0x71, 0x8C, 0xAE, 0x7B, 0xCF, 0x83, 
//	0x51, 0x74, 0xEB, 0x9A, 0x41, 0xF0, 0x00, 0xF8, 0xC3, 0xE8, 0xAA, 0xCA, 0xD3, 0xAC, 0xB6, 0x9D, 
//	0x55, 0xA5, 0xD3, 0xA4, 0x14, 0xA5, 0x96, 0xB5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x92, 0x94, 0xCF, 0x7B, 0xAE, 0x73, 0x55, 0xAD, 0x59, 0xCE, 0x30, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x79, 0xCE, 
//	0x34, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x5D, 0x4A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0x5F, 0x29, 0x5D, 0x4A, 0xD8, 0x7B, 0x14, 0xA5, 
//	0x73, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0x14, 0xA5, 0xD7, 0xBD, 0x9A, 0xD6, 0x34, 0xA5, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xD7, 0xBD, 0x18, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 
//	0x18, 0xC6, 0xD7, 0xBD, 0xB2, 0x94, 0xAE, 0x7B, 0xCF, 0x83, 0x51, 0x74, 0x49, 0xAA, 0xC7, 0xD9, 
//	0x30, 0xB4, 0xB6, 0x9D, 0x75, 0xA5, 0xF3, 0xA4, 0xF3, 0xA4, 0x75, 0xAD, 0x18, 0xC6, 0xBA, 0xD6, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF3, 0x9C, 0xCF, 0x7B, 0xAE, 0x73, 0xF3, 0x9C, 
//	0xF7, 0xBD, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0xF5, 0x9C, 0xFE, 0x39, 
//	0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 
//	0x9F, 0x31, 0x3F, 0x21, 0x7F, 0x29, 0xBB, 0x52, 0x57, 0x8C, 0x54, 0xAD, 0x73, 0xAD, 0x14, 0xA5, 
//	0x14, 0xA5, 0xD3, 0x9C, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0xD7, 0xBD, 0x18, 0xC6, 
//	0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0x18, 0xC6, 0xF7, 0xBD, 0x71, 0x8C, 
//	0xAE, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xF3, 0x94, 0x96, 0xA5, 0x14, 0xA5, 0xD3, 0xA4, 0x34, 0xA5, 
//	0xF7, 0xBD, 0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x55, 0xAD, 0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0x96, 0xB5, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x38, 0xC6, 
//	0x14, 0xA5, 0x54, 0xAD, 0xD5, 0x9C, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 
//	0xBE, 0x31, 0x1A, 0x63, 0x96, 0x94, 0x74, 0xAD, 0x33, 0xA5, 0x10, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x30, 0x84, 0x96, 0xB5, 0x18, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xD7, 0xBD, 0x18, 0xC6, 0xB6, 0xB5, 0x51, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 
//	0xD3, 0xA4, 0x34, 0xA5, 0xB6, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xAE, 0x73, 0xCF, 0x7B, 0x92, 0x94, 
//	0x34, 0xA5, 0xEF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x18, 0xC6, 0x13, 0xA5, 0x54, 0xAD, 0x76, 0x8C, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x3F, 0x21, 0x1D, 0x42, 0xB9, 0x73, 
//	0x52, 0x8C, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x55, 0xAD, 0x38, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0x38, 0xC6, 
//	0x55, 0xAD, 0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x7B, 0xB2, 0x94, 0x38, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xB6, 0xB5, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xF3, 0x9C, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 
//	0xF4, 0x9C, 0x54, 0xAD, 0x37, 0x84, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0xBF, 0x31, 0xBF, 0x31, 0x3F, 0x21, 0xBD, 0x31, 0x92, 0x73, 0x0E, 0x84, 0xAF, 0x73, 0x92, 0x94, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0xB2, 0x94, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0x51, 0x8C, 0x79, 0xCE, 0xFB, 0xDE, 0x9A, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 
//	0xB2, 0x94, 0xEF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xB7, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0xF8, 0x7B, 0x5F, 0x29, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x79, 0x4A, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xF0, 0x7B, 0x55, 0xAD, 0x18, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 
//	0x18, 0xC6, 0x96, 0xB5, 0x10, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0x75, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x18, 0xC6, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x71, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x96, 0xB5, 
//	0x14, 0xA5, 0x74, 0xAD, 0xB8, 0x73, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x7F, 0x29, 0x9E, 0x31, 0x34, 0x63, 0x4E, 0x8C, 0xAF, 0x73, 0x71, 0x8C, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x92, 0x94, 0xCF, 0x7B, 
//	0xAE, 0x73, 0xD3, 0x9C, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 
//	0x51, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x96, 0xB5, 0x14, 0xA5, 0x74, 0xAD, 0x99, 0x73, 0x3F, 0x21, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0xDC, 0x39, 0xB1, 0x73, 
//	0x0E, 0x84, 0xCF, 0x7B, 0x14, 0xA5, 0x18, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xD7, 0xBD, 0x18, 0xC6, 0x34, 0xA5, 0xEF, 0x7B, 0xAE, 0x73, 0x30, 0x84, 0x38, 0xC6, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xCE, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x51, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x76, 0xAD, 
//	0x14, 0xA5, 0x54, 0xAD, 0x5A, 0x6B, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0x3B, 0x42, 0xEF, 0x7B, 0xCE, 0x7B, 0x10, 0x84, 0x75, 0xAD, 0x18, 0xC6, 
//	0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0x18, 0xC6, 0x96, 0xB5, 0x30, 0x84, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x10, 0x84, 0xCF, 0x7B, 0x10, 0x84, 
//	0x30, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0xD3, 0x9C, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0x75, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x3A, 0x63, 0x5F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x99, 0x52, 0x0E, 0x84, 
//	0xCF, 0x7B, 0x31, 0x84, 0xB6, 0xB5, 0x18, 0xC6, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0x18, 0xC6, 0xD7, 0xBD, 0x51, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0x75, 0xAD, 0x1C, 0xE7, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x79, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 0x30, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0xD3, 0x9C, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x55, 0xAD, 
//	0x14, 0xA5, 0x54, 0xAD, 0x1A, 0x63, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x7F, 0x29, 0xB7, 0x52, 0x0E, 0x84, 0xAF, 0x73, 0x72, 0x8C, 0xF7, 0xBD, 0x18, 0xC6, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x92, 0x94, 
//	0xCF, 0x7B, 0xAE, 0x73, 0xF3, 0x9C, 0x79, 0xCE, 0x79, 0xCE, 0x59, 0xCE, 0x79, 0xCE, 0x59, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 0x79, 0xCE, 
//	0x79, 0xCE, 0x79, 0xCE, 0x59, 0xCE, 0x79, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x75, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x1A, 0x63, 0x5F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0xF6, 0x5A, 0x2E, 0x84, 
//	0xAF, 0x73, 0xB2, 0x94, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 
//	0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x54, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 
//	0x96, 0xB5, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x75, 0xAD, 
//	0x14, 0xA5, 0x54, 0xAD, 0x1A, 0x63, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x7F, 0x29, 0x9F, 0x31, 0xF6, 0x5A, 0x2E, 0x84, 0xAF, 0x73, 0xB2, 0x94, 0x18, 0xC6, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0xD3, 0x9C, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 0xF4, 0xAC, 
//	0xF4, 0xAC, 0xF4, 0xAC, 0x14, 0xA5, 0x14, 0xA5, 0xF3, 0x9C, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x1A, 0x63, 0x5F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x9F, 0x31, 0xF6, 0x5A, 0x2E, 0x84, 
//	0xAF, 0x73, 0x92, 0x94, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 
//	0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x54, 0x9D, 0x34, 0xA5, 0x34, 0xA5, 
//	0x14, 0xA5, 0x38, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x75, 0xAD, 
//	0x14, 0xA5, 0x54, 0xAD, 0x1A, 0x63, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x7F, 0x29, 0xD7, 0x5A, 0x2E, 0x84, 0xAF, 0x73, 0x72, 0x8C, 0xF7, 0xBD, 0x18, 0xC6, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x92, 0x94, 
//	0xCF, 0x73, 0xAF, 0x83, 0x4F, 0x55, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 0x2F, 
//	0x2F, 0x2F, 0x0F, 0x2F, 0x54, 0x9D, 0x14, 0xAD, 0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x30, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0xD3, 0x9C, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0x76, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x3A, 0x63, 0x5F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x98, 0x52, 0x0E, 0x84, 
//	0xCF, 0x7B, 0x51, 0x8C, 0xB6, 0xB5, 0x18, 0xC6, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF8, 0xC5, 0xD7, 0xBD, 0x71, 0x8C, 0xCF, 0x73, 0xB0, 0x8B, 0x0E, 0x36, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xCE, 0x07, 0x54, 0x95, 0x14, 0xAD, 
//	0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x79, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 0x51, 0x8C, 0xEF, 0x7B, 0xAE, 0x73, 0xD3, 0x9C, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x96, 0xB5, 
//	0x14, 0xA5, 0x74, 0xAD, 0x79, 0x6B, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0x3A, 0x42, 0x0F, 0x84, 0xCE, 0x7B, 0x10, 0x84, 0x75, 0xAD, 0x18, 0xC6, 
//	0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0x18, 0xC6, 0x96, 0xB5, 0x30, 0x84, 
//	0xAF, 0x7B, 0xCF, 0x83, 0x6E, 0x2E, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0x6F, 0x17, 0x54, 0x9D, 0x14, 0xA5, 0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 
//	0x51, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x96, 0xB5, 0x14, 0xA5, 0x74, 0xAD, 0x99, 0x73, 0x3F, 0x21, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0xFC, 0x39, 0xB1, 0x73, 
//	0x0E, 0x84, 0xD0, 0x7B, 0x34, 0xA5, 0x18, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xD7, 0xBD, 0x38, 0xC6, 0x34, 0xA5, 0x0F, 0x7C, 0xAF, 0x83, 0x2F, 0x74, 0xEE, 0x1E, 0xEE, 0x07, 
//	0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x6F, 0x1F, 0x54, 0x9D, 0x14, 0xA5, 
//	0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xCE, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x71, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xB6, 0xB5, 
//	0x14, 0xA5, 0x54, 0xAD, 0xD8, 0x7B, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x7F, 0x29, 0x9E, 0x31, 0x34, 0x63, 0x2E, 0x84, 0xAF, 0x73, 0x92, 0x94, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0xB2, 0x94, 0xEF, 0x73, 
//	0x8F, 0x8B, 0xEF, 0x5C, 0x8E, 0x0F, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0x4F, 0x27, 0x34, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 
//	0xB2, 0x94, 0xEF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xD7, 0xBD, 0x14, 0xA5, 0x54, 0xAD, 0xF8, 0x7B, 0x5F, 0x29, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x99, 0x52, 
//	0x0F, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0x75, 0xAD, 0x18, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 
//	0x18, 0xC6, 0x96, 0xB5, 0x30, 0x84, 0xEF, 0x73, 0xAF, 0x8B, 0x0E, 0x3E, 0xEE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x30, 0x2F, 0x34, 0xA5, 0x14, 0xA5, 
//	0x34, 0xA5, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x18, 0xC6, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0xF3, 0x9C, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 
//	0x14, 0xA5, 0x54, 0xAD, 0x37, 0x84, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0xFD, 0x39, 0xB1, 0x73, 0x0E, 0x84, 0xAF, 0x73, 0xB2, 0x94, 
//	0x18, 0xC6, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0x18, 0xC6, 0xD3, 0x9C, 0xEF, 0x73, 0xAF, 0x83, 
//	0x4F, 0x74, 0x0E, 0x1F, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0xF0, 0x36, 0x14, 0xAD, 0x14, 0xA5, 0x55, 0xAD, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 
//	0x14, 0xA5, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x18, 0xC6, 0x14, 0xA5, 0x54, 0xAD, 0x96, 0x94, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 
//	0xD7, 0x5A, 0x2E, 0x84, 0xCF, 0x7B, 0xF0, 0x7B, 0x75, 0xAD, 0x38, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0x18, 0xC6, 
//	0x75, 0xAD, 0x10, 0x84, 0xEF, 0x73, 0x90, 0x8B, 0x8F, 0x45, 0xCE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xD0, 0x46, 0x14, 0xAD, 0x14, 0xA5, 
//	0x55, 0xAD, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xB6, 0xB5, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0x75, 0xAD, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x38, 0xC6, 
//	0x14, 0xA5, 0x54, 0xAD, 0xD5, 0x9C, 0xBF, 0x31, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0xFD, 0x39, 0xB1, 0x73, 0x0E, 0x84, 0xAF, 0x73, 
//	0x51, 0x8C, 0xB6, 0xB5, 0x18, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xD7, 0xBD, 0x18, 0xC6, 0xD7, 0xBD, 0x51, 0x8C, 0xEF, 0x73, 0xAF, 0x83, 0x4F, 0x74, 
//	0x0E, 0x1F, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0x91, 0x56, 0x15, 0xAD, 0x14, 0xA5, 0x75, 0xAD, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xAE, 0x73, 0xCF, 0x7B, 0x92, 0x94, 
//	0xB6, 0xB5, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0xF5, 0x9C, 0xFE, 0x39, 
//	0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x7F, 0x29, 0x98, 0x52, 0x0E, 0x84, 0xEF, 0x7B, 0xAF, 0x73, 0x91, 0x94, 0xF7, 0xBD, 0x18, 0xC6, 
//	0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0x18, 0xC6, 0x17, 0xBE, 0x92, 0x94, 
//	0xCF, 0x73, 0xEF, 0x7B, 0x8F, 0x8B, 0x0E, 0x3E, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x32, 0x66, 0x14, 0xAD, 0x14, 0xA5, 
//	0xB6, 0xB5, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x55, 0xAD, 0xCF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0x18, 0xC6, 0x30, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x79, 0xCE, 
//	0x34, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x7C, 0x4A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x9E, 0x31, 0x15, 0x63, 0x2E, 0x84, 
//	0xD0, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xF7, 0xBD, 0x18, 0xC6, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 
//	0x18, 0xC6, 0xF7, 0xBD, 0xD3, 0x9C, 0xCF, 0x7B, 0x0F, 0x74, 0x90, 0x8B, 0x0F, 0x55, 0xAE, 0x0F, 
//	0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0xD2, 0x7D, 0x15, 0xAD, 0x13, 0x9D, 0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x14, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 
//	0xBA, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0xB6, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0xFB, 0x5A, 
//	0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x7F, 0x29, 0xBE, 0x31, 0x53, 0x6B, 0x2E, 0x84, 0xD0, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 
//	0xB6, 0xB5, 0x18, 0xC6, 0xF7, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0xD7, 0xBD, 0x92, 0x94, 0xCF, 0x7B, 0x0F, 0x74, 
//	0x90, 0x8B, 0xAF, 0x64, 0x6E, 0x0F, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0x93, 0x8D, 0x15, 0xAD, 0x14, 0xA5, 
//	0x18, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xB2, 0x94, 0xCF, 0x7B, 0xAE, 0x73, 0x55, 0xAD, 0xFB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x55, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0x75, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x5A, 0x6B, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0xFC, 0x39, 
//	0x91, 0x73, 0x2E, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0x75, 0xAD, 0x18, 0xC6, 0x18, 0xC6, 
//	0xF7, 0xBD, 0xD7, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xD7, 0xBD, 0xD7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0x18, 0xC6, 0x96, 0xB5, 
//	0x51, 0x8C, 0xCF, 0x73, 0x0F, 0x74, 0x90, 0x8B, 0x4F, 0x74, 0x0E, 0x1F, 0xEE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xAE, 0x0F, 0x73, 0x95, 0x14, 0xAD, 0x14, 0xA5, 0x38, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0x71, 0x8C, 0xCF, 0x7B, 0xAE, 0x73, 0x96, 0xB5, 
//	0x1C, 0xE7, 0xF3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xB6, 0xB5, 0x14, 0xA5, 0x74, 0xAD, 0xF8, 0x7B, 
//	0x5F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0xFC, 0x39, 0x73, 0x6B, 0x2E, 0x84, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0x0F, 0x84, 0xD3, 0x9C, 0x96, 0xB5, 0x18, 0xC6, 0x38, 0xC6, 0x18, 0xC6, 0x18, 0xC6, 
//	0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0x18, 0xC6, 0x38, 0xC6, 
//	0x18, 0xC6, 0x96, 0xB5, 0xD3, 0x9C, 0x10, 0x84, 0xEF, 0x73, 0xEF, 0x7B, 0x8F, 0x8B, 0x8F, 0x64, 
//	0x0E, 0x1F, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x4F, 0x27, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 
//	0x30, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0xD7, 0xBD, 0x3C, 0xE7, 0x34, 0xA5, 0xAE, 0x73, 0xCF, 0x7B, 
//	0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0xF4, 0x9C, 0x54, 0xAD, 0x76, 0x8C, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x7F, 0x29, 0xBD, 0x31, 0x15, 0x63, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 
//	0xB2, 0x94, 0x34, 0xA5, 0x96, 0xB5, 0xD7, 0xBD, 0xF7, 0xBD, 0x18, 0xC6, 0x18, 0xC6, 0x18, 0xC6, 
//	0x17, 0xBE, 0xD7, 0xBD, 0x96, 0xB5, 0x35, 0xAD, 0xB2, 0x94, 0x30, 0x84, 0xEF, 0x73, 0xEF, 0x73, 
//	0xCF, 0x83, 0x8F, 0x8B, 0x0F, 0x55, 0x4E, 0x17, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 
//	0xD0, 0x3E, 0x14, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 
//	0x5D, 0xEF, 0x96, 0xB5, 0xAE, 0x73, 0xCF, 0x7B, 0x51, 0x8C, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0x54, 0xAD, 0xF5, 0x9C, 
//	0xFE, 0x39, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x3F, 0x21, 0x3A, 0x63, 0xD1, 0x9C, 
//	0x10, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x30, 0x84, 0x71, 0x8C, 
//	0xB2, 0x94, 0xD3, 0x9C, 0xD3, 0x9C, 0xD3, 0x9C, 0x92, 0x94, 0x71, 0x8C, 0x30, 0x84, 0x0F, 0x7C, 
//	0xEF, 0x73, 0xEF, 0x73, 0xAF, 0x83, 0x90, 0x8B, 0x2F, 0x74, 0xEE, 0x3D, 0xAE, 0x0F, 0xEE, 0x07, 
//	0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x51, 0x5E, 0x15, 0xAD, 0x14, 0xA5, 0x95, 0xAD, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xF7, 0xBD, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0x3C, 0xE7, 0xF7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x10, 0x84, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x79, 0xCE, 0x34, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x7C, 0x4A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x5F, 0x29, 0x3D, 0x42, 0xD5, 0x9C, 0x74, 0xAD, 0xD3, 0x9C, 0xB2, 0x94, 0x51, 0x8C, 0xAE, 0x73, 
//	0xAE, 0x73, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x73, 0xCF, 0x73, 0xCF, 0x7B, 0xAF, 0x83, 0x8F, 0x8B, 0xB0, 0x8B, 0x2F, 0x74, 0x8F, 0x45, 
//	0x0E, 0x1F, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 
//	0xF2, 0x75, 0x15, 0xAD, 0x14, 0xA5, 0xB6, 0xB5, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0xBA, 0xD6, 
//	0x1C, 0xE7, 0x79, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 
//	0x1A, 0x63, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x7F, 0x29, 0xB9, 0x73, 0x93, 0xB5, 0x14, 0xA5, 
//	0x55, 0xAD, 0x59, 0xCE, 0x79, 0xCE, 0x55, 0xAD, 0xB2, 0x94, 0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xCE, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xAF, 0x83, 0x8F, 0x8B, 0xB0, 0x8B, 0xCF, 0x83, 0x2F, 0x74, 
//	0xEF, 0x5C, 0xEE, 0x3D, 0x0E, 0x1F, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0x93, 0x8D, 0x14, 0xAD, 0x14, 0xA5, 0x18, 0xC6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xF3, 0x9C, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x75, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0x96, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0xD8, 0x7B, 0x5F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x5F, 0x29, 
//	0x9C, 0x52, 0x14, 0xA5, 0x54, 0xAD, 0xF4, 0x9C, 0xD6, 0xBD, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x38, 0xC6, 0xB6, 0xB5, 0x75, 0xAD, 0xB2, 0x94, 0x51, 0x84, 0x51, 0x94, 0xB0, 0x7C, 
//	0x6F, 0x4D, 0xEE, 0x3D, 0x6E, 0x2E, 0xEE, 0x1E, 0x6E, 0x0F, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x6F, 0x1F, 
//	0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 0xAE, 0x73, 0x55, 0xAD, 0x1C, 0xE7, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xD3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0x14, 0xA5, 0x54, 0xAD, 
//	0x96, 0x94, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0xBE, 0x31, 0x17, 0x84, 0x93, 0xB5, 0xF4, 0x9C, 0x55, 0xAD, 
//	0x79, 0xCE, 0xDB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xD7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x6E, 0xCE, 0x07, 0xED, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xD0, 0x46, 0x14, 0xAD, 0x14, 0xA5, 0x54, 0xA5, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x30, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xD7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 0x1C, 0xE7, 0x34, 0xA5, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x3D, 0x42, 0x7F, 0x29, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0xFB, 0x5A, 
//	0x54, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x6E, 
//	0xEE, 0x07, 0xED, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x32, 0x66, 
//	0x15, 0xAD, 0x14, 0xA5, 0x96, 0xB5, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0x1C, 0xE7, 0xD7, 0xBD, 0xAE, 0x73, 0xEF, 0x7B, 0x30, 0x84, 0x79, 0xCE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x34, 0xA5, 0x34, 0xA5, 
//	0x54, 0xAD, 0xFB, 0x5A, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0xBF, 0x31, 0x5F, 0x29, 0xFE, 0x39, 0x96, 0x94, 0x73, 0xAD, 0xF4, 0x9C, 0x95, 0xB5, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xD7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0xF2, 0x75, 0xCE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xB3, 0x85, 0x14, 0xAD, 0x14, 0xA5, 0xD7, 0xBD, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x30, 0x84, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0x96, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0xD8, 0x7B, 0x5F, 0x29, 0xBF, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0x5A, 0x6B, 0x73, 0xAD, 
//	0x14, 0xA5, 0x14, 0xA5, 0x38, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x6E, 
//	0xEE, 0x07, 0xED, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x6F, 0x17, 0x54, 0x9D, 
//	0x34, 0xAD, 0x14, 0xA5, 0x38, 0xC6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xF3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x51, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0x55, 0xAD, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0xF4, 0x9C, 
//	0x54, 0xAD, 0x96, 0x94, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 
//	0x5F, 0x29, 0x3D, 0x42, 0xF5, 0x9C, 0x74, 0xAD, 0xF4, 0x9C, 0xB6, 0xB5, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xD7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xCE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xCE, 0x07, 0xED, 0x07, 0xD0, 0x46, 0x14, 0xAD, 0x14, 0xA5, 0x54, 0xA5, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x71, 0x8C, 0xCF, 0x7B, 
//	0xAE, 0x73, 0x55, 0xAD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xF3, 0x9C, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x7C, 0x4A, 0x5F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x9F, 0x31, 0xD8, 0x7B, 0x93, 0xB5, 0xF4, 0x9C, 
//	0x34, 0xA5, 0x59, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x12, 0x6E, 0x15, 0xAD, 
//	0x14, 0xA5, 0x96, 0xB5, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x96, 0xB5, 0xAE, 0x73, 0xEF, 0x7B, 0x30, 0x84, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x55, 0xAD, 
//	0x14, 0xA5, 0x54, 0xAD, 0x79, 0x6B, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 
//	0xBC, 0x52, 0x34, 0xA5, 0x34, 0xA5, 0xF4, 0x9C, 0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x0F, 0x73, 0x95, 0x15, 0xAD, 0x14, 0xA5, 0x18, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x10, 0x84, 0x79, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x38, 0xC6, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x18, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xB6, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0x57, 0x8C, 0x7F, 0x29, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0xBE, 0x31, 0x37, 0x84, 0x93, 0xB5, 0xF4, 0x9C, 0x75, 0xAD, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x10, 0x2F, 0x14, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xFB, 0xDE, 0x34, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0x55, 0xAD, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 
//	0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x3D, 0x42, 0x7F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0x1A, 0x63, 
//	0x73, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0x32, 0x66, 0x15, 0xAD, 0x14, 0xA5, 0x75, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x14, 0xA5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xF3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x5A, 0x6B, 
//	0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0xFE, 0x39, 0x96, 0x94, 0x73, 0xAD, 0xF4, 0x9C, 0x95, 0xB5, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xAE, 0x0F, 0x73, 0x95, 0x14, 0xAD, 0x13, 0x9D, 
//	0xF7, 0xBD, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xD7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xB6, 0xB5, 0x14, 0xA5, 0x54, 0xAD, 0x76, 0x8C, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x7F, 0x29, 0x79, 0x6B, 0x93, 0xB5, 
//	0x14, 0xA5, 0x34, 0xA5, 0x38, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 
//	0x10, 0x37, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 
//	0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x79, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xB6, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 
//	0x5D, 0x4A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 
//	0x5F, 0x29, 0x5D, 0x4A, 0xF5, 0x9C, 0x54, 0xAD, 0xF4, 0x9C, 0xB6, 0xB5, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x12, 0x6E, 0x14, 0xAD, 0x14, 0xA5, 0x75, 0xAD, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xD3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0xB9, 0x73, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x9F, 0x31, 0xF8, 0x7B, 0x93, 0xB5, 0xF4, 0x9C, 
//	0x55, 0xAD, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xAE, 0x17, 
//	0x54, 0x9D, 0x14, 0xAD, 0x14, 0x9D, 0xF7, 0xBD, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x30, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0x75, 0xAD, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x1C, 0xE7, 0x75, 0xAD, 0xAE, 0x73, 0xEF, 0x7B, 0x30, 0x84, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xD7, 0xBD, 0x14, 0xA5, 0x54, 0xAD, 
//	0xD5, 0x9C, 0xDE, 0x39, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 
//	0xBB, 0x52, 0x54, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0xF7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xB0, 0x4E, 0x14, 0xAD, 0x14, 0xA5, 0x34, 0xA5, 0x79, 0xCE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x79, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x54, 0xAD, 0xFB, 0x5A, 0x3F, 0x21, 0xBF, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0xDE, 0x39, 0x57, 0x8C, 0x73, 0xAD, 0xF4, 0x9C, 0x75, 0xAD, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xB3, 0x85, 
//	0x14, 0xAD, 0x14, 0xA5, 0x96, 0xB5, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xF3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x96, 0xB5, 0x14, 0xA5, 
//	0x54, 0xAD, 0x57, 0x8C, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0x3A, 0x63, 
//	0x73, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xCE, 0x07, 0xED, 0x07, 0x2F, 0x2F, 0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x38, 0xC6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x30, 0x84, 
//	0xEF, 0x7B, 0xAE, 0x73, 0x75, 0xAD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x75, 0xAD, 0xAE, 0x73, 
//	0xEF, 0x7B, 0x30, 0x84, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x7C, 0x4A, 0x5F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0x1D, 0x42, 0xB5, 0x94, 0x74, 0xAD, 0xF4, 0x9C, 0x96, 0xB5, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x12, 0x6E, 0x14, 0xAD, 
//	0x14, 0xA5, 0x55, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xB6, 0xB5, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 
//	0x14, 0xA5, 0x54, 0xAD, 0xF8, 0x7B, 0x5F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x7F, 0x29, 0x99, 0x73, 0x93, 0xB5, 
//	0xF4, 0x9C, 0x34, 0xA5, 0x59, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0x6F, 0x1F, 0x34, 0x9D, 0x34, 0xAD, 0x14, 0xA5, 0xF7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xD3, 0x9C, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x92, 0x94, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x92, 0x94, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0xF4, 0x9C, 0x54, 0xAD, 0x14, 0xA5, 0x3D, 0x42, 
//	0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x5F, 0x29, 0x7C, 0x4A, 0x14, 0xA5, 0x54, 0xAD, 0xF4, 0x9C, 0xB6, 0xB5, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x31, 0x66, 0x14, 0xAD, 0x14, 0xA5, 
//	0x34, 0xA5, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0x75, 0xAD, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x96, 0xB5, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 
//	0x35, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0xB9, 0x73, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x9E, 0x31, 0xF7, 0x7B, 0x93, 0xB5, 0xF4, 0x9C, 
//	0x55, 0xAD, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 
//	0x8E, 0x17, 0x54, 0x9D, 0x34, 0xAD, 0xF4, 0x9C, 0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0x10, 0x84, 0x79, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 
//	0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0x34, 0xA5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD7, 0xBD, 0xF4, 0x9C, 0x54, 0xAD, 0xF5, 0x9C, 
//	0x1D, 0x42, 0x7F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 
//	0xDB, 0x5A, 0x54, 0xAD, 0x34, 0xA5, 0xF4, 0x9C, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x51, 0x5E, 0x14, 0xAD, 0x34, 0xA5, 0x34, 0xA5, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0xEF, 0x7B, 0x51, 0x8C, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x34, 0xA5, 0x34, 0xA5, 0x54, 0xAD, 0xD8, 0x7B, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0xBF, 0x31, 0x5F, 0x29, 0xDE, 0x39, 0x76, 0x8C, 0x73, 0xAD, 0xF4, 0x9C, 0x75, 0xAD, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x6F, 0x1F, 
//	0x54, 0x9D, 0x14, 0xAD, 0x14, 0x9D, 0xB7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xF7, 0xBD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xF7, 0xBD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x18, 0xC6, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD7, 0xBD, 0xF3, 0x9C, 0x54, 0xAD, 
//	0x14, 0xA5, 0x3D, 0x42, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x3A, 0x63, 
//	0x73, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x38, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x52, 0x66, 0x14, 0xAD, 0x34, 0xA5, 0x34, 0xA5, 0x79, 0xCE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xF3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x9A, 0xD6, 0x34, 0xA5, 0x14, 0xA5, 0x53, 0xAD, 0xF8, 0x7B, 0x5F, 0x29, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0x3D, 0x42, 0xD5, 0x9C, 0x74, 0xAD, 0xF4, 0x9C, 0x96, 0xB5, 0xBB, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x6F, 0x1F, 0x54, 0x9D, 
//	0x14, 0xAD, 0x14, 0xA5, 0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0x55, 0xAD, 
//	0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0x1C, 0xE7, 0xB6, 0xB5, 0xAE, 0x73, 0xEF, 0x7B, 0xCF, 0x7B, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0xF4, 0x9C, 
//	0x54, 0xAD, 0x34, 0xA5, 0x9C, 0x52, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x7F, 0x29, 0xB9, 0x73, 0x93, 0xB5, 
//	0xF4, 0x9C, 0x34, 0xA5, 0x59, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xCE, 0x07, 0xED, 0x07, 0x12, 0x6E, 0x14, 0xAD, 0x14, 0xA5, 0x34, 0xA5, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x34, 0xA5, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0x30, 0x84, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x57, 0x8C, 0x7F, 0x29, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x5F, 0x29, 0x9C, 0x52, 0x34, 0xA5, 0x34, 0xA5, 0xF4, 0x9C, 0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x10, 0x37, 0x14, 0xA5, 0x35, 0xAD, 
//	0x13, 0x9D, 0xF7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x10, 0x84, 0xEF, 0x7B, 0xAE, 0x73, 0x14, 0xA5, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0x1C, 0xE7, 0x55, 0xAD, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x18, 0xC6, 
//	0xF4, 0x9C, 0x34, 0xA5, 0x54, 0xAD, 0xFB, 0x5A, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0xBE, 0x31, 0x37, 0x84, 0x93, 0xB5, 0xF4, 0x9C, 
//	0x55, 0xAD, 0x99, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xB3, 0x85, 0x15, 0xAD, 0x14, 0xA5, 0x55, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0x59, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 0x10, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x14, 0xA5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x75, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0xB5, 0x94, 
//	0xDE, 0x39, 0x7F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 
//	0xFB, 0x5A, 0x73, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x91, 0x4E, 0x14, 0xAD, 0x34, 0xA5, 0x13, 0x9D, 
//	0x38, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0x51, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0xEF, 0x7B, 0x10, 0x84, 0x59, 0xCE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xCE, 0x14, 0xA5, 0x34, 0xA5, 0x54, 0xAD, 0xB9, 0x73, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0xFE, 0x39, 0x96, 0x94, 0x73, 0xAD, 0xF4, 0x9C, 0x75, 0xAD, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x6F, 0x1F, 
//	0x54, 0x9D, 0x14, 0xAD, 0x14, 0xA5, 0x75, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0x18, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x14, 0xA5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xB6, 0xB5, 0xF4, 0x9C, 0x54, 0xAD, 
//	0x34, 0xA5, 0x7C, 0x4A, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x5A, 0x6B, 
//	0x93, 0xB5, 0xF4, 0x9C, 0x34, 0xA5, 0x38, 0xC6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xF2, 0x75, 0xF4, 0xAC, 0x34, 0xA5, 0x14, 0xA5, 0x59, 0xCE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0xEF, 0x7B, 0x10, 0x84, 
//	0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x9A, 0xD6, 0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0x76, 0x8C, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0x3D, 0x42, 0xF5, 0x9C, 0x54, 0xAD, 0xF4, 0x9C, 0xB6, 0xB5, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xD0, 0x3E, 0x14, 0xAD, 
//	0x34, 0xAD, 0x14, 0x9D, 0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0x18, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x79, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x18, 0xC6, 0x14, 0xA5, 
//	0x34, 0xA5, 0x54, 0xAD, 0x99, 0x73, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x9F, 0x31, 0xD8, 0x7B, 0x93, 0xB5, 
//	0xF4, 0x9C, 0x34, 0xA5, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0x6E, 0x1F, 0x54, 0x95, 0x14, 0xAD, 0x14, 0xA5, 0x55, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x34, 0xA5, 0xAE, 0x73, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0x38, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x96, 0xB5, 0xF4, 0x9C, 0x54, 0xAD, 0x34, 0xA5, 0x9C, 0x52, 
//	0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x5F, 0x29, 0x9C, 0x52, 0x34, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xF2, 0x75, 0xF4, 0xAC, 0x34, 0xA5, 
//	0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x55, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x18, 0xC6, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0x79, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xB2, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 
//	0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0xB5, 0x94, 0xDE, 0x39, 0x7F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0xBE, 0x31, 0x57, 0x8C, 0x73, 0xAD, 0xF4, 0x9C, 
//	0x75, 0xAD, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 
//	0x91, 0x4E, 0x14, 0xAD, 0x34, 0xAD, 0x14, 0x9D, 0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x10, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x75, 0xAD, 0xAE, 0x73, 
//	0x10, 0x84, 0xCF, 0x7B, 0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 0xF4, 0x9C, 0x34, 0xA5, 0x73, 0xAD, 
//	0x18, 0x84, 0x5F, 0x29, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 
//	0x1B, 0x63, 0x73, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x2F, 0x2F, 0x34, 0xA5, 0x15, 0xAD, 0x14, 0x9D, 0x75, 0xAD, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xF3, 0x9C, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xB6, 0xB5, 0xF4, 0x9C, 0x54, 0xAD, 0x54, 0xAD, 0x5A, 0x6B, 0x3F, 0x21, 0xBF, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0xFE, 0x39, 0xB6, 0x94, 0x73, 0xAD, 0xF4, 0x9C, 0x96, 0xB5, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x8E, 0x17, 0x73, 0x8D, 
//	0x15, 0xAD, 0x34, 0xA5, 0x34, 0xA5, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x18, 0xC6, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xAE, 0x73, 0x34, 0xA5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xD7, 0xBD, 
//	0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x75, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x55, 0xAD, 0xF4, 0x9C, 
//	0x54, 0xAD, 0x14, 0xA5, 0x9C, 0x52, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x79, 0x6B, 
//	0x93, 0xB5, 0xF4, 0x9C, 0x34, 0xA5, 0x59, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xED, 0x07, 0xF2, 0x75, 0xF4, 0xAC, 0x34, 0xA5, 0x14, 0x9D, 0x18, 0xC6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xB2, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0xD5, 0x9C, 0x1D, 0x42, 
//	0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0x5D, 0x4A, 0x14, 0xA5, 0x54, 0xAD, 0xF4, 0x9C, 0xB6, 0xB5, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x71, 0x56, 0xF4, 0xAC, 0x34, 0xAD, 
//	0x13, 0x9D, 0xB6, 0xB5, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 
//	0x96, 0xB5, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x38, 0xC6, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x38, 0xC6, 
//	0x14, 0xA5, 0x34, 0xA5, 0x73, 0xAD, 0x57, 0x8C, 0xBF, 0x31, 0x7F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x9E, 0x31, 0xF8, 0x7B, 0x93, 0xB5, 
//	0xF4, 0x9C, 0x55, 0xAD, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 
//	0xD0, 0x3E, 0x14, 0xA5, 0x15, 0xAD, 0x14, 0x9D, 0x75, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 
//	0x10, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x34, 0xA5, 0xAE, 0x73, 0x10, 0x84, 
//	0xCF, 0x7B, 0x96, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xD7, 0xBD, 0xF4, 0x9C, 0x34, 0xA5, 0x53, 0xAD, 
//	0x18, 0x84, 0x7F, 0x29, 0x9F, 0x31, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x5F, 0x29, 0xBC, 0x52, 0x54, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x2F, 0x2F, 0x34, 0x9D, 0x15, 0xAD, 0x14, 0xA5, 0x34, 0xA5, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xD3, 0x9C, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x38, 0xC6, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x79, 0xCE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0x96, 0xB5, 0xF4, 0x9C, 0x54, 0xAD, 0x53, 0xAD, 0xB8, 0x73, 0x5F, 0x29, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0xDE, 0x39, 0x76, 0x8C, 0x73, 0xAD, 0xF4, 0x9C, 
//	0x75, 0xAD, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x6F, 0x1F, 0x73, 0x95, 
//	0x14, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xB6, 0xB5, 0xCF, 0x7B, 
//	0x10, 0x84, 0xAE, 0x73, 0x34, 0xA5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x18, 0xC6, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x75, 0xAD, 0x14, 0xA5, 
//	0x54, 0xAD, 0x54, 0xAD, 0x7A, 0x6B, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 
//	0x1A, 0x63, 0x73, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0x8E, 0x17, 0x93, 0x85, 0xF5, 0xAC, 0x34, 0xA5, 0x14, 0x9D, 0x18, 0xC6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x79, 0xCE, 0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x96, 0xB5, 
//	0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 0x14, 0xA5, 0x54, 0xAD, 0x34, 0xA5, 0x3A, 0x63, 
//	0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0x1D, 0x42, 0xD5, 0x9C, 0x54, 0xAD, 0xF4, 0x9C, 0x96, 0xB5, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xAE, 0x17, 0xB3, 0x85, 0xF4, 0xAC, 0x34, 0xA5, 
//	0x13, 0x9D, 0xD7, 0xBD, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xB2, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0x51, 0x8C, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x59, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 
//	0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0x34, 0xA5, 0x3A, 0x63, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x7F, 0x29, 0xB9, 0x73, 
//	0x93, 0xB5, 0xF4, 0x9C, 0x34, 0xA5, 0x59, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xAE, 0x0F, 
//	0xD3, 0x7D, 0xF4, 0xAC, 0x34, 0xA5, 0xF3, 0x9C, 0xB6, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 
//	0x96, 0xB5, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0x14, 0xA5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x18, 0xC6, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0x92, 0x94, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 
//	0x34, 0xA5, 0x1A, 0x63, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0x7C, 0x4A, 0x34, 0xA5, 0x34, 0xA5, 0xF4, 0x9C, 0xD6, 0xBD, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xCE, 0x07, 0xED, 0x07, 0xAE, 0x0F, 0xD3, 0x7D, 0xF4, 0xAC, 0x34, 0xA5, 0x13, 0x9D, 0x96, 0xB5, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 0x38, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0x55, 0xAD, 0xAE, 0x73, 0x10, 0x84, 0xAE, 0x73, 0x55, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0x59, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0x34, 0xA5, 0x1A, 0x63, 0x3F, 0x21, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0xBF, 0x31, 0x7F, 0x29, 0x9E, 0x31, 0x18, 0x84, 0x93, 0xB5, 
//	0xF4, 0x9C, 0x55, 0xAD, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xAE, 0x17, 0xD3, 0x7D, 0xF4, 0xAC, 
//	0x34, 0xA5, 0x13, 0x9D, 0x96, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x71, 0x8C, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x92, 0x94, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x58, 0xCE, 0x34, 0xA5, 
//	0x14, 0xA5, 0x54, 0xAD, 0x34, 0xA5, 0x5A, 0x6B, 0x5F, 0x29, 0x9F, 0x31, 0xBF, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x5F, 0x29, 0xDB, 0x5A, 0x53, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 
//	0x8E, 0x17, 0xB3, 0x85, 0xF4, 0xAC, 0x34, 0xA5, 0x13, 0x9D, 0x96, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xF3, 0x9C, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0x75, 0xAD, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x59, 0xCE, 
//	0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0x54, 0xAD, 
//	0x79, 0x6B, 0x5F, 0x29, 0x9F, 0x31, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0xDE, 0x39, 0x96, 0x94, 0x73, 0xAD, 0xF4, 0x9C, 
//	0x75, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x8F, 0x1F, 0xB3, 0x85, 0xF4, 0xAC, 0x34, 0xA5, 0x14, 0x9D, 
//	0x96, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xAE, 0x73, 0xB2, 0x94, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xD7, 0xBD, 
//	0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 0x71, 0x8C, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x59, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0x54, 0xAD, 0xD8, 0x7B, 0x9F, 0x31, 0x7F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 
//	0x5A, 0x6B, 0x93, 0xB5, 0x14, 0xA5, 0x34, 0xA5, 0x38, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0x2F, 0x27, 0x73, 0x8D, 
//	0xF4, 0xAC, 0x34, 0xA5, 0xF3, 0x9C, 0x96, 0xB5, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 
//	0x18, 0xC6, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x55, 0xAD, 0xAE, 0x73, 0x10, 0x84, 0xAE, 0x73, 
//	0xF3, 0x9C, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x59, 0xCE, 0x34, 0xA5, 0x14, 0xA5, 
//	0x54, 0xAD, 0x53, 0xAD, 0x37, 0x84, 0xDE, 0x39, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0x3D, 0x42, 0xF5, 0x9C, 0x54, 0xAD, 0xF4, 0x9C, 0x96, 0xB5, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0xF0, 0x36, 0x54, 0x9D, 0xF4, 0xAC, 0x34, 0xA5, 0xF3, 0x9C, 0xB6, 0xB5, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 0x79, 0xCE, 0x30, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0x18, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xD3, 0x9C, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x55, 0xAD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0x79, 0xCE, 0x55, 0xAD, 0x14, 0xA5, 0x34, 0xA5, 0x73, 0xAD, 0x96, 0x94, 
//	0x3D, 0x42, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0x9F, 0x31, 0xB9, 0x73, 
//	0x93, 0xB5, 0xF4, 0x9C, 0x34, 0xA5, 0x59, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xED, 0x07, 0xB1, 0x4E, 0x34, 0xA5, 0x15, 0xAD, 0x34, 0xA5, 
//	0x14, 0x9D, 0xD7, 0xBD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x92, 0x94, 
//	0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0xB6, 0xB5, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0x51, 0x8C, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x96, 0xB5, 0xFB, 0xDE, 0x9A, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 
//	0x75, 0xAD, 0xF4, 0x9C, 0x34, 0xA5, 0x54, 0xAD, 0xF5, 0x9C, 0xDB, 0x5A, 0x5F, 0x29, 0x9F, 0x31, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x5F, 0x29, 0x7C, 0x4A, 0x34, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0xD7, 0xBD, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xCE, 0x0F, 0x32, 0x66, 
//	0x14, 0xAD, 0x15, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0xF7, 0xBD, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xD3, 0x9C, 0xAE, 0x73, 0x10, 0x84, 0xAE, 0x73, 0x14, 0xA5, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xF7, 0xBD, 
//	0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xB6, 0xB5, 0x14, 0xA5, 0x34, 0xA5, 
//	0x54, 0xAD, 0x34, 0xA5, 0x99, 0x73, 0x9F, 0x31, 0x5F, 0x29, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x7F, 0x29, 0xBE, 0x31, 0x37, 0x84, 0x93, 0xB5, 
//	0xF4, 0x9C, 0x55, 0xAD, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xED, 0x07, 0x6F, 0x1F, 0xB3, 0x85, 0xF4, 0xAC, 0x34, 0xAD, 0x14, 0xA5, 0x34, 0xA5, 0x38, 0xC6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0x10, 0x84, 
//	0xAE, 0x73, 0xB2, 0x94, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xF7, 0xBD, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x38, 0xC6, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x17, 0xC6, 0x14, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0x53, 0xAD, 0x56, 0x8C, 
//	0x1D, 0x42, 0x3F, 0x21, 0xBF, 0x31, 0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x9F, 0x31, 
//	0x7F, 0x29, 0xFB, 0x5A, 0x73, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0xF7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xED, 0x07, 0xD0, 0x3E, 0x54, 0x9D, 0x15, 0xAD, 0x34, 0xA5, 
//	0x14, 0x9D, 0x55, 0xAD, 0x59, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0x1C, 0xE7, 
//	0x75, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xB6, 0xB5, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 
//	0x30, 0x84, 0x59, 0xCE, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x59, 0xCE, 
//	0x55, 0xAD, 0x14, 0xA5, 0x34, 0xA5, 0x74, 0xAD, 0xF5, 0x9C, 0xFB, 0x5A, 0x5F, 0x29, 0x7F, 0x29, 
//	0xBF, 0x31, 0x9F, 0x31, 0x9F, 0x31, 0x5F, 0x29, 0xFE, 0x39, 0x96, 0x94, 0x73, 0xAD, 0xF4, 0x9C, 
//	0x75, 0xAD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xAE, 0x0F, 0x32, 0x66, 
//	0x14, 0xA5, 0x14, 0xAD, 0x34, 0xA5, 0x14, 0x9D, 0x96, 0xB5, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 
//	0x79, 0xCE, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0x75, 0xAD, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x51, 0x8C, 0x79, 0xCE, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0x96, 0xB5, 0xF4, 0x9C, 0x34, 0xA5, 
//	0x54, 0xAD, 0x54, 0xAD, 0xF8, 0x7B, 0xDE, 0x39, 0x3F, 0x21, 0xBF, 0x31, 0x9F, 0x31, 0x7F, 0x29, 
//	0x5A, 0x6B, 0x93, 0xB5, 0xF4, 0x9C, 0x34, 0xA5, 0x38, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xED, 0x07, 0x2F, 0x2F, 0x93, 0x8D, 0xF4, 0xAC, 0x34, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0xF7, 0xBD, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xFB, 0xDE, 0xB6, 0xB5, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x38, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x34, 0xA5, 0xAE, 0x73, 
//	0x10, 0x84, 0xAE, 0x73, 0x71, 0x8C, 0x9A, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xF7, 0xBD, 0x14, 0xA5, 0x14, 0xA5, 0x54, 0xAD, 0x53, 0xAD, 0xD5, 0x9C, 
//	0xDB, 0x5A, 0x7F, 0x29, 0x1F, 0x21, 0x3D, 0x42, 0xF5, 0x9C, 0x54, 0xAD, 0xF4, 0x9C, 0xB6, 0xB5, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xAE, 0x0F, 0x51, 0x5E, 0x34, 0xA5, 0x14, 0xAD, 0x34, 0xA5, 
//	0x14, 0x9D, 0x55, 0xAD, 0x38, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0x1C, 0xE7, 0xD7, 0xBD, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xF7, 0xBD, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF3, 0x9C, 0xAE, 0x73, 0x10, 0x84, 0xAE, 0x73, 0x92, 0x94, 
//	0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x59, 0xCE, 
//	0x75, 0xAD, 0xF4, 0x9C, 0x34, 0xA5, 0x54, 0xAD, 0x54, 0xAD, 0xF7, 0x7B, 0x3D, 0x42, 0xD8, 0x7B, 
//	0x93, 0xB5, 0xF4, 0x9C, 0x34, 0xA5, 0x79, 0xCE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xED, 0x07, 0xF0, 0x36, 0x93, 0x8D, 
//	0xF4, 0xAC, 0x14, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0xB6, 0xB5, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x1C, 0xE7, 0xD7, 0xBD, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xD7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xD3, 0x9C, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x92, 0x94, 0x9A, 0xD6, 0xFB, 0xDE, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0x9A, 0xD6, 0xD7, 0xBD, 0x14, 0xA5, 0x14, 0xA5, 
//	0x54, 0xAD, 0x54, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0xD7, 0xBD, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xED, 0x07, 
//	0x6F, 0x1F, 0x12, 0x6E, 0x14, 0xA5, 0x15, 0xAD, 0x34, 0xA5, 0x14, 0x9D, 0x34, 0xA5, 0x18, 0xC6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xD7, 0xBD, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0xB6, 0xB5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0xB2, 0x94, 0xAE, 0x73, 0x10, 0x84, 
//	0xAE, 0x73, 0x71, 0x8C, 0x79, 0xCE, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x59, 0xCE, 0x75, 0xAD, 0xF4, 0x9C, 0x34, 0xA5, 0x54, 0xAD, 0x34, 0xA5, 
//	0x14, 0xA5, 0x75, 0xAD, 0x9A, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xED, 0x07, 0xAE, 0x0F, 0x71, 0x56, 0x54, 0x9D, 0x15, 0xAD, 0x34, 0xAD, 0x14, 0xA5, 
//	0x14, 0xA5, 0xB6, 0xB5, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0x1C, 0xE7, 0xB6, 0xB5, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x96, 0xB5, 
//	0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xB2, 0x94, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x51, 0x8C, 0x59, 0xCE, 
//	0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xF7, 0xBD, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x18, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xED, 0x07, 0xCE, 0x07, 0xD0, 0x46, 0x93, 0x8D, 0xF4, 0xAC, 
//	0x14, 0xAD, 0x34, 0xA5, 0x13, 0x9D, 0x55, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0x1C, 0xE7, 0x96, 0xB5, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xAE, 0x73, 0x96, 0xB5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xF3, 0x9C, 
//	0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x30, 0x84, 0x38, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x79, 0xCE, 0xB6, 0xB5, 0x34, 0xA5, 
//	0xD7, 0xBD, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xED, 0x07, 0xEE, 0x07, 0xF0, 0x3E, 
//	0xB3, 0x85, 0x14, 0xAD, 0x14, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0xF7, 0xBD, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x75, 0xAD, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xB6, 0xB5, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x14, 0xA5, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 
//	0x10, 0x84, 0xD7, 0xBD, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0x9A, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xED, 0x07, 
//	0xCE, 0x07, 0xD0, 0x3E, 0xB3, 0x85, 0x14, 0xAD, 0x14, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0x96, 0xB5, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x34, 0xA5, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xB6, 0xB5, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0x34, 0xA5, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x75, 0xAD, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xED, 0x07, 0xED, 0x07, 0xAE, 0x0F, 0x91, 0x4E, 0x93, 0x8D, 0x14, 0xAD, 0x14, 0xAD, 0x34, 0xA5, 
//	0x14, 0xA5, 0x14, 0x9D, 0x75, 0xAD, 0x38, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xD3, 0x9C, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xD7, 0xBD, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x75, 0xAD, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x34, 0xA5, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xEE, 0x07, 0xED, 0x07, 0xEE, 0x07, 0x4F, 0x27, 0x51, 0x5E, 0x73, 0x95, 0x14, 0xAD, 
//	0x14, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0x9D, 0x75, 0xAD, 0x38, 0xC6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0xFB, 0xDE, 
//	0x79, 0xCE, 0x92, 0x94, 0xAE, 0x73, 0x10, 0x84, 0xAE, 0x73, 0x10, 0x84, 0x18, 0xC6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xD7, 0xBD, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 
//	0xB2, 0x94, 0x9A, 0xD6, 0xFB, 0xDE, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xED, 0x07, 0xED, 0x07, 0xAE, 0x0F, 0xD0, 0x46, 0xD3, 0x7D, 
//	0x34, 0xA5, 0x14, 0xAD, 0x14, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x75, 0xAD, 0x38, 0xC6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x18, 0xC6, 0x30, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 
//	0x51, 0x8C, 0x59, 0xCE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x18, 0xC6, 0x10, 0x84, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 0x51, 0x8C, 0x38, 0xC6, 0x1C, 0xE7, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x76, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xED, 0x07, 0xED, 0x07, 0xAE, 0x0F, 0xF0, 0x3E, 
//	0x12, 0x6E, 0x74, 0x95, 0x14, 0xAD, 0x14, 0xAD, 0x34, 0xAD, 0x34, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0x96, 0xB5, 0x59, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x96, 0xB5, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0xB2, 0x94, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x79, 0xCE, 0x71, 0x8C, 0xAE, 0x73, 
//	0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x96, 0xB5, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x6E, 
//	0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xED, 0x07, 0xED, 0x07, 0xEE, 0x07, 0x8F, 0x17, 
//	0xD0, 0x3E, 0x12, 0x6E, 0x73, 0x95, 0x14, 0xAD, 0x15, 0xAD, 0x14, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 
//	0x14, 0x9D, 0x55, 0xAD, 0xD7, 0xBD, 0x79, 0xCE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0x9A, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xF3, 0x9C, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x14, 0xA5, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0xF3, 0x9C, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xF3, 0x9C, 0xBA, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xD7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0x12, 0x6E, 0xEE, 0x07, 0xED, 0x07, 0xCE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 
//	0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xEE, 0x07, 0x8E, 0x0F, 
//	0x30, 0x2F, 0x71, 0x56, 0xD3, 0x7D, 0x54, 0x9D, 0x14, 0xAD, 0x15, 0xAD, 0x14, 0xAD, 0x34, 0xA5, 
//	0x14, 0xA5, 0x14, 0x9D, 0x14, 0xA5, 0x96, 0xB5, 0x18, 0xC6, 0x9A, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x38, 0xC6, 0x71, 0x8C, 0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xB6, 0xB5, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0x96, 0xB5, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x71, 0x8C, 0x18, 0xC6, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0xF5, 0xB4, 0xF2, 0x75, 
//	0xAE, 0x0F, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xCE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 0xEE, 0x07, 
//	0xEE, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xEE, 0x07, 0xAE, 0x0F, 0x4F, 0x27, 
//	0xD0, 0x3E, 0x51, 0x66, 0xD3, 0x7D, 0x54, 0x95, 0x14, 0xA5, 0x15, 0xAD, 0x15, 0xAD, 0x34, 0xAD, 
//	0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x75, 0xAD, 0xF7, 0xBD, 0x79, 0xCE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0x75, 0xAD, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0x10, 0x84, 0xAE, 0x73, 0x30, 0x84, 0x38, 0xC6, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x18, 0xC6, 0x30, 0x84, 0xAE, 0x73, 
//	0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x55, 0xAD, 0xDB, 0xDE, 0xDB, 0xDE, 0x9A, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xD7, 0xBD, 0x13, 0x9D, 0xD5, 0xB4, 0x12, 0x6E, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 0xED, 0x07, 
//	0xEE, 0x07, 0xEE, 0x07, 0xCE, 0x07, 0xAE, 0x0F, 0x6F, 0x1F, 0x2F, 0x2F, 0xD0, 0x46, 0x71, 0x56, 
//	0x12, 0x6E, 0xB3, 0x85, 0x73, 0x95, 0x34, 0xA5, 0x14, 0xAD, 0x15, 0xAD, 0x15, 0xAD, 0x34, 0xAD, 
//	0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x96, 0xB5, 0xF7, 0xBD, 0x79, 0xCE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 
//	0x79, 0xCE, 0xB2, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0xB2, 0x94, 0x9A, 0xD6, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0xD3, 0x9C, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0x92, 0x94, 0x38, 0xC6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xF7, 0xBD, 0x13, 0x9D, 0x14, 0xAD, 0x93, 0x8D, 
//	0x51, 0x66, 0x51, 0x66, 0x32, 0x66, 0x12, 0x6E, 0xD2, 0x7D, 0xB3, 0x85, 0x93, 0x8D, 0x54, 0x9D, 
//	0x34, 0x9D, 0x34, 0xA5, 0x14, 0xAD, 0x15, 0xAD, 0x15, 0xAD, 0x15, 0xAD, 0x34, 0xAD, 0x34, 0xAD, 
//	0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 0x75, 0xAD, 0xD7, 0xBD, 0x38, 0xC6, 
//	0x9A, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xB6, 0xB5, 0x10, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0x75, 0xAD, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0x96, 0xB5, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x55, 0xAD, 0xBA, 0xD6, 
//	0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xD7, 0xBD, 0xF4, 0xA4, 0x34, 0xA5, 0x34, 0xAD, 0x15, 0xB5, 0x15, 0xAD, 0x15, 0xAD, 0x15, 0xAD, 
//	0x15, 0xAD, 0x15, 0xAD, 0x15, 0xAD, 0x34, 0xAD, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0x14, 0x9D, 0x14, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x95, 0xAD, 0xD7, 0xBD, 0x38, 0xC6, 
//	0x79, 0xCE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x59, 0xCE, 0xB2, 0x94, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x51, 0x8C, 0x38, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0x92, 0x94, 0xAE, 0x73, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x71, 0x8C, 0x18, 0xC6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xF7, 0xBD, 0xF3, 0x9C, 0x14, 0xA5, 0x14, 0xA5, 
//	0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x14, 0xA5, 0x13, 0xA5, 0x14, 0xA5, 
//	0x34, 0xA5, 0x34, 0xA5, 0x55, 0xAD, 0x75, 0xAD, 0xB6, 0xB5, 0xF7, 0xBD, 0x38, 0xC6, 0x79, 0xCE, 
//	0x9A, 0xD6, 0xBA, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0x96, 0xB5, 0x10, 0x84, 0xCF, 0x7B, 0x10, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0x14, 0xA5, 0xBA, 0xD6, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x75, 0xAD, 0xEF, 0x7B, 0xAE, 0x73, 0x10, 0x84, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xF3, 0x9C, 0x79, 0xCE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0x9A, 0xD6, 0xD7, 0xBD, 0x75, 0xAD, 0xB6, 0xB5, 0x96, 0xB5, 0xB6, 0xB5, 0xB6, 0xB5, 0xD7, 0xBD, 
//	0xF7, 0xBD, 0x18, 0xC6, 0x38, 0xC6, 0x38, 0xC6, 0x59, 0xCE, 0x9A, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x18, 0xC6, 0x92, 0x94, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 
//	0x51, 0x8C, 0x18, 0xC6, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 
//	0x59, 0xCE, 0xB2, 0x94, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x55, 0xAD, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0xF3, 0x9C, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0x34, 0xA5, 0xBA, 0xD6, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xB6, 0xB5, 0x10, 0x84, 
//	0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0xB6, 0xB5, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0x55, 0xAD, 
//	0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x92, 0x94, 0x38, 0xC6, 0x1C, 0xE7, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0x9A, 0xD6, 0x14, 0xA5, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0xD7, 0xBD, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x9A, 0xD6, 0x75, 0xAD, 0x30, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xAE, 0x73, 0x30, 0x84, 
//	0xB6, 0xB5, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0x38, 0xC6, 0xB2, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0x92, 0x94, 0xF7, 0xBD, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0x75, 0xAD, 0x30, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xAE, 0x73, 0xEF, 0x7B, 0x34, 0xA5, 0x9A, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xF7, 0xBD, 
//	0x71, 0x8C, 0xAE, 0x73, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x92, 0x94, 0xD7, 0xBD, 
//	0xBA, 0xD6, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 0x55, 0xAD, 0x30, 0x84, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0x59, 0xCE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xB6, 0xB5, 0x51, 0x8C, 0xAE, 0x73, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x71, 0x8C, 0x96, 0xB5, 0x9A, 0xD6, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0x59, 0xCE, 0x14, 0xA5, 
//	0x10, 0x84, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xD3, 0x9C, 0x38, 0xC6, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0x1C, 0xE7, 0xDB, 0xDE, 0xB6, 0xB5, 0x51, 0x8C, 0xAE, 0x73, 0xCF, 0x7B, 0x10, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x34, 0xA5, 0x38, 0xC6, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0xF7, 0xBD, 0xD3, 0x9C, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xB2, 0x94, 0x18, 0xC6, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 
//	0xBA, 0xD6, 0xB6, 0xB5, 0x71, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xB2, 0x94, 0xD7, 0xBD, 0x9A, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0x59, 0xCE, 0x55, 0xAD, 0x51, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xAE, 0x73, 0xEF, 0x7B, 0xD3, 0x9C, 0x38, 0xC6, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0xDB, 0xDE, 0xF7, 0xBD, 
//	0xB2, 0x94, 0xCF, 0x7B, 0xAE, 0x73, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 
//	0x14, 0xA5, 0x18, 0xC6, 0xBA, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0x79, 0xCE, 0xB6, 0xB5, 0xD3, 0x9C, 0x10, 0x84, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 0x10, 0x84, 0x34, 0xA5, 0x59, 0xCE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 0x38, 0xC6, 0x14, 0xA5, 0x10, 0x84, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0x34, 0xA5, 
//	0x18, 0xC6, 0xBA, 0xD6, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0xD7, 0xBD, 0xD3, 0x9C, 0x10, 0x84, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0x75, 0xAD, 0x9A, 0xD6, 
//	0x1C, 0xE7, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x9A, 0xD6, 0xB6, 0xB5, 0x92, 0x94, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x51, 0x8C, 0x14, 0xA5, 0xD7, 0xBD, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x59, 0xCE, 0x96, 0xB5, 0xD3, 0x9C, 0x30, 0x84, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 0x10, 0x84, 0xF3, 0x9C, 
//	0xF7, 0xBD, 0xDB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0x1C, 0xE7, 0xDB, 0xDE, 0x38, 0xC6, 0x34, 0xA5, 0x51, 0x8C, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x92, 0x94, 0x55, 0xAD, 0xF7, 0xBD, 
//	0x79, 0xCE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x79, 0xCE, 0xD7, 0xBD, 0x34, 0xA5, 0x71, 0x8C, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 0xEF, 0x7B, 
//	0x92, 0x94, 0x96, 0xB5, 0x9A, 0xD6, 0x1C, 0xE7, 0x1C, 0xE7, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0x18, 0xC6, 0x34, 0xA5, 0x51, 0x8C, 0xCF, 0x7B, 0xAE, 0x73, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x30, 0x84, 0x92, 0x94, 0x34, 0xA5, 0xD7, 0xBD, 
//	0x59, 0xCE, 0x9A, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 
//	0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xBA, 0xD6, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 0x9A, 0xD6, 0x38, 0xC6, 0x96, 0xB5, 0x14, 0xA5, 0x71, 0x8C, 
//	0x10, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 
//	0xEF, 0x7B, 0x92, 0x94, 0x75, 0xAD, 0x59, 0xCE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xBA, 0xD6, 
//	0x18, 0xC6, 0x55, 0xAD, 0x92, 0x94, 0xEF, 0x7B, 0xAE, 0x73, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0x51, 0x8C, 0xB2, 0x94, 0x14, 0xA5, 
//	0x96, 0xB5, 0x18, 0xC6, 0x59, 0xCE, 0x9A, 0xD6, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 
//	0xBA, 0xD6, 0x79, 0xCE, 0x59, 0xCE, 0xF7, 0xBD, 0x75, 0xAD, 0xF3, 0x9C, 0x92, 0x94, 0x30, 0x84, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x30, 0x84, 0xD3, 0x9C, 0x96, 0xB5, 0x59, 0xCE, 0xFB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 0x59, 0xCE, 
//	0xB6, 0xB5, 0xD3, 0x9C, 0x51, 0x8C, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0x10, 0x84, 0x51, 0x8C, 
//	0x71, 0x8C, 0xD3, 0x9C, 0x34, 0xA5, 0x75, 0xAD, 0xB6, 0xB5, 0xD7, 0xBD, 0xF7, 0xBD, 0x38, 0xC6, 
//	0x59, 0xCE, 0x59, 0xCE, 0x79, 0xCE, 0x9A, 0xD6, 0x9A, 0xD6, 0x9A, 0xD6, 0x9A, 0xD6, 0x9A, 0xD6, 
//	0x9A, 0xD6, 0x9A, 0xD6, 0x79, 0xCE, 0x59, 0xCE, 0x59, 0xCE, 0x18, 0xC6, 0xF7, 0xBD, 0xD7, 0xBD, 
//	0x96, 0xB5, 0x55, 0xAD, 0x14, 0xA5, 0xB2, 0x94, 0x71, 0x8C, 0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 
//	0xCF, 0x7B, 0x10, 0x84, 0x71, 0x8C, 0x34, 0xA5, 0xF7, 0xBD, 0x9A, 0xD6, 0xFB, 0xDE, 0x1C, 0xE7, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 0xBA, 0xD6, 0x59, 0xCE, 
//	0xB6, 0xB5, 0x14, 0xA5, 0x71, 0x8C, 0x10, 0x84, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x10, 0x84, 
//	0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xCF, 0x7B, 0x30, 0x84, 0x92, 0x94, 0x34, 0xA5, 0xF7, 0xBD, 0x79, 0xCE, 0xDB, 0xDE, 0x1C, 0xE7, 
//	0x1C, 0xE7, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 0xDB, 0xDE, 0x79, 0xCE, 
//	0x18, 0xC6, 0x96, 0xB5, 0x14, 0xA5, 0x92, 0x94, 0x30, 0x84, 0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 
//	0xAE, 0x73, 0xCF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xCF, 0x7B, 
//	0xEF, 0x7B, 0xCF, 0x7B, 0xCF, 0x7B, 0xAE, 0x73, 0xAE, 0x73, 0xCF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 
//	0x51, 0x8C, 0xD3, 0x9C, 0x34, 0xA5, 0xB6, 0xB5, 0x38, 0xC6, 0x9A, 0xD6, 0xFB, 0xDE, 0x1C, 0xE7, 
//	0x1C, 0xE7, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0x1C, 0xE7, 0xFB, 0xDE, 
//	0xBA, 0xD6, 0x59, 0xCE, 0x18, 0xC6, 0xB6, 0xB5, 0x55, 0xAD, 0x14, 0xA5, 0xB2, 0x94, 0x71, 0x8C, 
//	0x51, 0x8C, 0x51, 0x8C, 0x30, 0x84, 0x10, 0x84, 0x10, 0x84, 0x10, 0x84, 0xEF, 0x7B, 0xEF, 0x7B, 
//	0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0xEF, 0x7B, 0x10, 0x84, 0x10, 0x84, 
//	0x10, 0x84, 0x30, 0x84, 0x30, 0x84, 0x51, 0x8C, 0x51, 0x8C, 0x71, 0x8C, 0xD3, 0x9C, 0x14, 0xA5, 
//	0x75, 0xAD, 0xD7, 0xBD, 0x38, 0xC6, 0x9A, 0xD6, 0xBA, 0xD6, 0xFB, 0xDE, 0x1C, 0xE7, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0x3C, 0xE7, 0x3C, 0xE7, 
//	0x3C, 0xE7, 0x3C, 0xE7, 0xFB, 0xDE, 0xFB, 0xDE, 0xDB, 0xDE, 0x79, 0xCE, 0x38, 0xC6, 0xD7, 0xBD, 
//	0x96, 0xB5, 0x96, 0xB5, 0x55, 0xAD, 0x14, 0xA5, 0x34, 0xA5, 0x34, 0xA5, 0x14, 0xA5, 0x34, 0xA5, 
//	0x14, 0xA5, 0x14, 0xA5, 0x75, 0xAD, 0x96, 0xB5, 0x96, 0xB5, 0xF7, 0xBD, 0x38, 0xC6, 0x9A, 0xD6, 
//	0xDB, 0xDE, 0xFB, 0xDE, 0x1C, 0xE7, 0x3C, 0xE7, 0x5D, 0xEF, 0x3C, 0xE7, 0x1C, 0xE7, 0x1C, 0xE7, 
//	0xFB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 
//	0xDB, 0xDE, 0xDB, 0xDE, 0xDB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 
//	0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE, 0xFB, 0xDE
//};
